#include "config_unix.h"
#include "config_win32.h"
#include "gettimeofday.h"

#ifdef WINCE
int gettimeofday(struct timeval *tp, void *tz)
{
	DWORD timemillis = timeGetTime();

	tp->tv_sec  = timemillis/1000;
	tp->tv_usec = (timemillis - (tp->tv_sec*1000)) * 1000;
	
	return 0;
}
#else //WINCE


#if defined(NEED_GETTIMEOFDAY) && defined(WIN32)

int gettimeofday(struct timeval *tp, void *tz)
{
	struct _timeb timebuffer;   

	_ftime( &timebuffer );
	tp->tv_sec  = timebuffer.time;
	tp->tv_usec = timebuffer.millitm * 1000;
	return 0;
}

#endif

#endif
