#! /usr/bin/perl -w
######################################################################
# Copyright (C) 2001 Peter J Jones (pjones@pmade.org)
# All Rights Reserved
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the Author nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR
# OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
# AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
######################################################################

require 'test_harness.pl';
my $program = "./directory_recursive_test";
my $directory = "test_recur_dir";

$program = "$program.exe" if ($^O =~ /win/i && $^O !~ /darwin/i);
$program = "$program.app" if ($^O =~ /darwin/i);

my $path = $directory;
system("mkdir $directory");

print "Making test directories, please wait ";

foreach (1..200) {
    $path .= "/test";
    system("mkdir $path");
    system("touch $path/abc");
    print ".";
}

print "\n";

print "Running find program ... \n";
@find_out = sort `find . -type f`;

print "Running test program ... \n";
@sord_out = sort `$program`;

test_start("same size");

if (@sord_out == @find_out) {
    test_passed();
} else {
    test_failed();
}

for (my $i=0; $i<@sord_out; ++$i) {
    test_start("entry $i");

    if ($sord_out[$i] eq $find_out[$i]) {
	test_passed();
    } else {
	test_failed();
    }
}

if (not all_tests_passed()) {
    print "Dumping test output to disk\n";
    if (open(ONE, ">find.out") && open(TWO, ">sord.out")) {
	print ONE @find_out;
	print TWO @sord_out;
    }
}

print "please wait while I clean up those directories ...\n";
system("rm -rf $directory");
