//----------------------------
// Codec installation
// - copies codec to Windows System32 directory
// - calls regsvr32 with the codec on cmdline to register it
//----------------------------
#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <errno.h>

#define CODEC_NAME "xvid_dshow.ax"

//----------------------------

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

   int ok;
                              //ask user if s/he agrees
#ifndef _DEBUG
   ok = MessageBox(NULL, "This will install XviD codec. Click OK to continue, or Cancel to abort installation.",
      "Install XviD codec", MB_OKCANCEL | MB_ICONINFORMATION);
   if(ok!=IDOK)
      return 1;
#endif
                              //copy to Windows system dir
   char sys_path[MAX_PATH];
   GetSystemDirectory(sys_path, sizeof(sys_path));
   char dst_path[MAX_PATH];
   strcpy(dst_path, sys_path);
   strcat(dst_path, "\\"CODEC_NAME);
   ok = CopyFile(CODEC_NAME, dst_path, false);
   if(!ok){
      MessageBox(NULL, "Failed to copy codec file to target directory!", "Copy error", MB_OK);
      return 2;
   }
   char exe_path[MAX_PATH];
   strcpy(exe_path, sys_path);
   strcat(exe_path, "\\regsvr32.exe");
                              //register the codec
   ok = _spawnlp(_P_WAIT,
      exe_path,
      exe_path,
      "/s",
      dst_path,
      NULL);
   if(ok!=0){
      const char *err = "unknown error";
      switch(errno){
      case E2BIG: err = "argument list exceeds 1024 bytes"; break;
      case EINVAL: err = "mode argument is invalid"; break;
      case ENOENT: err = "file or path is not found"; break;
      case ENOEXEC: err = "specified file is not executable or has invalid executable-file format"; break;
      case ENOMEM: err = "not enough memory is available to execute new process"; break;
      }
      char buf[512];
      sprintf(buf, "Codec register error \"%s\": regsvr32 returned %i", err, ok);
      MessageBox(NULL, buf, "DLL register error", MB_OK);
      return ok;
   }
   MessageBox(NULL, "Installation was successful.", "Codec installed", MB_OK);
   return 0;
}

//----------------------------
