@echo off

set ELIB=c:\Symbian\6.1\Series60\Epoc32\Release\armi\urel
set APP_ID=101feafa
set EPOCLIBS="%ELIB%\EDLL.LIB" "%ELIB%\EDLLSTUB.LIB" "%ELIB%\EGCC.LIB" "%ELIB%\euser.lib"
set BDIR=_Symbian_ARM\
set OBJS=%BDIR%bitstream.o %BDIR%CodecAPI.o %BDIR%Decoder.o %BDIR%Font.o %BDIR%Gmc.o %BDIR%Idct.o %BDIR%Image.o %BDIR%Interpolate8x8.o %BDIR%mbcoding.o %BDIR%MbPrediction.o %BDIR%Mem_align.o %BDIR%Mem_transfer.o %BDIR%Qpel_tab.o %BDIR%Quant_h263.o %BDIR%Quant_matrix.o %BDIR%Quant_mpeg.o %BDIR%Reduced.o %BDIR%Xvid.o %BDIR%Xvid_as_arm.o

if not exist _tmp mkdir _tmp

rem// generate 1st pass .exp file
dlltool -m arm_interwork --def Codec_ARM.def --output-exp %BDIR%tmp.exp --dllname MyGame[%APP_ID%].APP
if errorlevel 1 goto fail

rem// lik 1st pass
ld -s -e _E32Dll -u _E32Dll %BDIR%tmp.exp --dll --base-file %BDIR%tmp.bas -o _tmp\tmp.app %OBJS% %EPOCLIBS% -Map %BDIR%app.map
if errorlevel 1 goto fail

rem// generate 2nd pass .exp file
dlltool -m arm_interwork --def Codec_ARM.def --dllname MyGame[%APP_ID%].APP --base-file %BDIR%tmp.bas --output-exp %BDIR%tmp.exp
if errorlevel 1 goto fail

rem// lik 2nd pass
ld  -s -e _E32Dll -u _E32Dll --dll %BDIR%tmp.exp -o _tmp\tmp.app %OBJS% %EPOCLIBS%
if errorlevel 1 goto fail

rem// process by petran
petran _tmp\tmp.app _tmp\tmp.app -nocall -uid1 0x10000079 -uid2 0x100039ce -uid3 0x%APP_ID% >nul
if errorlevel 1 goto fail

rem// finalize - make .sis packaged file

makesis Codec_XviD_S60.pkg
if errorlevel 1 goto fail

makesis Codec_XviD_UIQ.pkg
if errorlevel 1 goto fail

goto end

:fail
@echo Failed!

:end

