
.text
.align 0
.arm

@----------------------------

.global interpolate8x8_halfpel_hv__FPUcPCUcUlb
.global XVID_ClearMatrix__FPv
.global InverseDiscreteCosineTransform_ARM__FPiPCi


@----------------------------
@ r0 = dst
@ r1 = src
@ r2 = stride
@ r3 = y
@ r4 = src[stride]
@ r5 - r9, r12 = work
@----------------------------
interpolate8x8_halfpel_hv__FPUcPCUcUlb:

   stmfd sp!, { r4 - r9, r14 }

   tst r3, r3
   movne r14, #1
   moveq r14, #2

   mov r3, #8
.ihhv_loop:
   add r4, r1, r2
   ldrb r5, [r1, #8]
   ldrb r7, [r4, #8]
   add r5, r5, r7
                           @7+8
   ldrb r6, [r1, #7]
   ldrb r7, [r4, #7]
   add r6, r6, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r8, r7, asr #2
                           @6+7
   ldrb r5, [r1, #6]
   ldrb r7, [r4, #6]
   add r5, r5, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8
                           @5+6
   ldrb r6, [r1, #5]
   ldrb r7, [r4, #5]
   add r6, r6, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8
                           @4+5
   ldrb r5, [r1, #4]
   ldrb r7, [r4, #4]
   add r5, r5, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8

   str r8, [r0, #4]

                           @3+4
   ldrb r6, [r1, #3]
   ldrb r7, [r4, #3]
   add r6, r6, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r8, r7, asr #2
                           @2+3
   ldrb r5, [r1, #2]
   ldrb r7, [r4, #2]
   add r5, r5, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8
                           @1+2
   ldrb r6, [r1, #1]
   ldrb r7, [r4, #1]
   add r6, r6, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8
                           @0+1
   ldrb r5, [r1, #0]
   ldrb r7, [r4, #0]
   add r5, r5, r7
   add r7, r5, r6
   add r7, r7, r14
   mov r7, r7, asr #2
   orr r8, r7, r8, asl #8

   str r8, [r0, #0]

   add r0, r0, r2
   add r1, r1, r2
   subs r3, r3, #1
   bne .ihhv_loop

   ldmfd sp!, { r4 - r9, r14 }
   bx lr

@----------------------------
XVID_ClearMatrix__FPv:

   mov r1, #0
   mov r2, #0
   mov r3, #0
   mov r12, #0
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }

   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }
   stmia r0!, { r1, r2, r3, r12 }

   bx lr

@----------------------------
InverseDiscreteCosineTransform_ARM__FPiPCi:
@ r0...r8 = X0...X8
@ r9 = clip table
@ r12 = <free>
@ r14 = block ptr
@locals:
@ sp[0] = counter
@----------------------------
   stmfd sp!, { r4 - r9, r14 }
   sub sp, sp, #4          @local vars

   mov r14, r0
   mov r9, r1

                              @idct rows
   mov r12, #8
   str r12, [sp, #0]
.idct_row_loop:
   ldr r0, [r14, #0*4]
   ldr r1, [r14, #4*4]
   ldr r2, [r14, #6*4]
   ldr r3, [r14, #2*4]
   ldr r4, [r14, #1*4]
   ldr r5, [r14, #7*4]
   ldr r6, [r14, #5*4]
   ldr r7, [r14, #3*4]

   orr r12, r1, r2
   orr r12, r12, r3
   orr r12, r12, r4
   orr r12, r12, r5
   orr r12, r12, r6
   orrs r12, r12, r7
   bne .idct_row_nz
                              @zero row
   mov r12, r0, asl #3
   str r12, [r14, #0*4]
   str r12, [r14, #1*4]
   str r12, [r14, #2*4]
   str r12, [r14, #3*4]
   str r12, [r14, #4*4]
   str r12, [r14, #5*4]
   str r12, [r14, #6*4]
   str r12, [r14, #7*4]
   b .idct_row_next
   
.idct_row_nz:
   mov r0, r0, asl #11
   mov r1, r1, asl #11
   add r0, r0, #128

                              @first stage

                              @X8 = W7 * (X4 + X5);
   add r8, r4, r5
   ldr r12, .idct_W7
   mul r8, r12, r8
                              @X4 = X8 + (W1 - W7) * X4;
   ldr r12, .idct_W1_M_W7
   mul r4, r12, r4
   add r4, r8, r4
                              @X5 = X8 - (W1 + W7) * X5;
   ldr r12, .idct_W1_P_W7
   mul r5, r12, r5
   sub r5, r8, r5
                              @X8 = W3 * (X6 + X7);
   add r8, r6, r7
   ldr r12, .idct_W3
   mul r8, r12, r8
                              @X6 = X8 - (W3 - W5) * X6;
   ldr r12, .idct_W3_M_W5
   mul r6, r12, r6
   sub r6, r8, r6
                              @X7 = X8 - (W3 + W5) * X7;
   ldr r12, .idct_W3_P_W5
   mul r7, r12, r7
   sub r7, r8, r7

                              @second stage

                              @X8 = X0 + X1;
   add r8, r0, r1
                              @X0 -= X1;
   sub r0, r0, r1
                              @X1 = W6 * (X3 + X2);
   ldr r12, .idct_W6
   add r1, r3, r2
   mul r1, r12, r1
                              @X2 = X1 - (W2 + W6) * X2;
   ldr r12, .idct_W2_P_W6
   mul r2, r12, r2
   sub r2, r1, r2
                              @X3 = X1 + (W2 - W6) * X3;
   ldr r12, .idct_W2_M_W6
   mul r3, r12, r3
   add r3, r1, r3
                              @X1 = X4 + X6;
   add r1, r4, r6
                              @X4 -= X6;
   sub r4, r4, r6
                              @X6 = X5 + X7;
   add r6, r5, r7
                              @X5 -= X7;
   sub r5, r5, r7
   

                              @third stage
                              @X7 = X8 + X3;
   add r7, r8, r3
                              @X8 -= X3;
   sub r8, r8, r3
                              @X3 = X0 + X2;
   add r3, r0, r2
                              @X0 -= X2;
   sub r0, r0, r2
                              @X2 = (181 * (X4 + X5) + 128) >> 8;
   mov r12, #181
   add r2, r4, r5
   mul r2, r12, r2
   add r2, r2, #128
   mov r2, r2, asr #8
                              @X4 = (181 * (X4 - X5) + 128) >> 8;
   sub r4, r4, r5
   mul r4, r12, r4
   add r4, r4, #128
   mov r4, r4, asr #8
   

                              @fourth stage
   add r12, r7, r1
   mov r12, r12, asr #8
   str r12, [r14, #0*4]

   add r12, r3, r2
   mov r12, r12, asr #8
   str r12, [r14, #1*4]

   add r12, r0, r4
   mov r12, r12, asr #8
   str r12, [r14, #2*4]

   add r12, r8, r6
   mov r12, r12, asr #8
   str r12, [r14, #3*4]

   sub r12, r8, r6
   mov r12, r12, asr #8
   str r12, [r14, #4*4]

   sub r12, r0, r4
   mov r12, r12, asr #8
   str r12, [r14, #5*4]

   sub r12, r3, r2
   mov r12, r12, asr #8
   str r12, [r14, #6*4]

   sub r12, r7, r1
   mov r12, r12, asr #8
   str r12, [r14, #7*4]

.idct_row_next:
   add r14, r14, #8*4
   ldr r12, [sp, #0]
   subs r12, r12, #1
   str r12, [sp, #0]
   bne .idct_row_loop

   sub r14, r14, #8*8*4

                              @idct columns
   mov r12, #8
   str r12, [sp, #0]
.idct_column_loop:
   ldr r0, [r14, #8*0*4]
   ldr r1, [r14, #8*4*4]
   ldr r2, [r14, #8*6*4]
   ldr r3, [r14, #8*2*4]
   ldr r4, [r14, #8*1*4]
   ldr r5, [r14, #8*7*4]
   ldr r6, [r14, #8*5*4]
   ldr r7, [r14, #8*3*4]

   orr r12, r1, r2
   orr r12, r12, r3
   orr r12, r12, r4
   orr r12, r12, r5
   orr r12, r12, r6
   orrs r12, r12, r7
   bne .idct_column_nz
                              @zero column
   add r12, r0, #32
   mov r12, r12, asr #6
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*0*4]
   str r12, [r14, #8*1*4]
   str r12, [r14, #8*2*4]
   str r12, [r14, #8*3*4]
   str r12, [r14, #8*4*4]
   str r12, [r14, #8*5*4]
   str r12, [r14, #8*6*4]
   str r12, [r14, #8*7*4]
   b .idct_column_next

.idct_column_nz:
   mov r0, r0, asl #8
   mov r1, r1, asl #8
   add r0, r0, #8192

                              @first stage

                              @int X8 = __W7 * (X4 + X5) + 4;
   add r8, r4, r5
   ldr r12, .idct_W7
   mul r8, r12, r8
   add r8, r8, #4
                              @X4 = (X8 + (__W1 - __W7) * X4) >> 3;
   ldr r12, .idct_W1_M_W7
   mul r4, r12, r4
   add r4, r8, r4
   mov r4, r4, asr #3
                              @X5 = (X8 - (__W1 + __W7) * X5) >> 3;
   ldr r12, .idct_W1_P_W7
   mul r5, r12, r5
   sub r5, r8, r5
   mov r5, r5, asr #3
                              @X8 = __W3 * (X6 + X7) + 4;
   add r8, r6, r7
   ldr r12, .idct_W3
   mul r8, r12, r8
   add r8, r8, #4
                              @X6 = (X8 - (__W3 - __W5) * X6) >> 3;
   ldr r12, .idct_W3_M_W5
   mul r6, r12, r6
   sub r6, r8, r6
   mov r6, r6, asr #3
                              @X7 = (X8 - (__W3 + __W5) * X7) >> 3;
   ldr r12, .idct_W3_P_W5
   mul r7, r12, r7
   sub r7, r8, r7
   mov r7, r7, asr #3

                              @second stage
                              @X8 = X0 + X1;
   add r8, r0, r1 
                              @X0 -= X1;
   sub r0, r0, r1
                              @X1 = __W6 * (X3 + X2) + 4;
   ldr r12, .idct_W6
   add r1, r3, r2
   mul r1, r12, r1
   add r1, r1, #4
                              @X2 = (X1 - (__W2 + __W6) * X2) >> 3;
   ldr r12, .idct_W2_P_W6
   mul r2, r12, r2
   sub r2, r1, r2
   mov r2, r2, asr #3
                              @X3 = (X1 + (__W2 - __W6) * X3) >> 3;
   ldr r12, .idct_W2_M_W6
   mul r3, r12, r3
   add r3, r1, r3
   mov r3, r3, asr #3
                              @X1 = X4 + X6;
   add r1, r4, r6
                              @X4 -= X6;
   sub r4, r4, r6
                              @X6 = X5 + X7;
   add r6, r5, r7
                              @X5 -= X7;
   sub r5, r5, r7


                              @third stage
                              @X7 = X8 + X3;
   add r7, r8, r3
                              @X8 -= X3;
   sub r8, r8, r3
                              @X3 = X0 + X2;
   add r3, r0, r2
                              @X0 -= X2;
   sub r0, r0, r2
                              @X2 = (181 * (X4 + X5) + 128) >> 8;
   mov r12, #181
   add r2, r4, r5
   mul r2, r12, r2
   add r2, r2, #128
   mov r2, r2, asr #8
                              @X4 = (181 * (X4 - X5) + 128) >> 8;
   sub r4, r4, r5
   mul r4, r12, r4
   add r4, r4, #128
   mov r4, r4, asr #8

                              @fourth stage
   add r12, r7, r1
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*0*4]

   add r12, r3, r2
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*1*4]

   add r12, r0, r4
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*2*4]

   add r12, r8, r6
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*3*4]

   sub r12, r8, r6
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*4*4]

   sub r12, r0, r4
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*5*4]

   sub r12, r3, r2
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*6*4]

   sub r12, r7, r1
   mov r12, r12, asr #14
   ldr r12, [r9, r12, asl#2]
   str r12, [r14, #8*7*4]

.idct_column_next:
   add r14, r14, #4
   ldr r12, [sp, #0]
   subs r12, r12, #1
   str r12, [sp, #0]
   bne .idct_column_loop
   

   add sp, sp, #4
   ldmfd sp!, { r4 - r9, r14 }

   bx lr

.idct_W1:
.word 2841
.idct_W2:
.word 2676
.idct_W3:
.word 2408
.idct_W5:
.word 1609
.idct_W6:
.word 1108
.idct_W7:
.word 565
.idct_W1_M_W7:
.word 2276
.idct_W1_P_W7:
.word 3406
.idct_W3_M_W5:
.word 799
.idct_W3_P_W5:
.word 4017
.idct_W2_M_W6:
.word 1568
.idct_W2_P_W6:
.word 3784


@----------------------------
