#include <windows.h>
#include <process.h>

static const char err[] = "ActiveSync is not installed. Please install Microsoft ActiveSync and run setup again.";
static const char err_t[] = "XviD codec installation error";

//----------------------------

static HKEY RegkeyOpen(const char *name){

   HKEY key;
   int i = RegOpenKeyEx(HKEY_LOCAL_MACHINE, name, 0, KEY_EXECUTE | KEY_WRITE | KEY_QUERY_VALUE, &key);
   if(i != ERROR_SUCCESS)
      return 0;
   return key;
}

//----------------------------

static int RegkeyRdata(HKEY key, const char *valname, void *mem1, int len1){

   DWORD len = len1;
   int i = RegQueryValueEx(key, valname, 0, NULL, (byte*)mem1, &len);
   if(i == ERROR_SUCCESS) return len;
   if(i == ERROR_MORE_DATA){
      byte *tmp = new byte[len];
      if(!tmp) return -1;
      i = RegQueryValueEx(key, valname, 0, NULL, tmp, &len);
      if(i == ERROR_SUCCESS){
         memcpy(mem1, tmp, len1);
         delete[] tmp;
         return len1;
      }
      delete[] tmp;
   }
   return -1;
}

//----------------------------

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

                              //get path to app manager
   HKEY rk = RegkeyOpen("Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\CEAPPMGR.EXE");
   if(!rk){
      MessageBox(NULL, err, err_t, MB_OK);
      return 1;
   }
   char mgr_path[MAX_PATH];
   RegkeyRdata(rk, NULL, mgr_path, sizeof(mgr_path));
   RegCloseKey(rk);

   int ok = MessageBox(NULL, "This will install XviD codec on your Pocket PC device. Press OK to continue.", "XviD installation", MB_OKCANCEL);
   if(ok!=IDOK)
      return 1;

                              //get curr dir
   char path[MAX_PATH+2];
   path[0] = '\"';
   GetModuleFileName(hInstance, path+1, sizeof(path));
   for(int i=strlen(path); i--; ){
      if(path[i]=='\\'){
         path[i+1] = 0;
         break;
      }
   }
   strcat(path, "xvid.ini\"");

   char cmdline[MAX_PATH*2];
   strcpy(cmdline, mgr_path);
   strcat(cmdline, " ");
   strcat(cmdline, path);

   int sp = _spawnl(_P_WAIT, mgr_path, cmdline, NULL);
   if(sp==-1)
      MessageBox(NULL, err, err_t, MB_OK);
   return sp;
}

//----------------------------
