  /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	adaptationenginedialog.h                                *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_ADAPTATIONENGINEDIALOGBASE_
#define _PS_ADAPTATIONENGINEDIALOGBASE_
#include "adaptationenginedialogbase.hpp"
#include <cstdio>

class ContainerInfo;

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: adaptationenginedialog.hpp,v 1.3 2004/06/23 13:44:03 pschojer Exp $
 *
 *@short <short description>
 *
 */
class AdaptationEngineDialog : public AdaptationEngineDialogBase
{
	Q_OBJECT
public:
	AdaptationEngineDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags f = 0 );
	virtual ~AdaptationEngineDialog();
protected slots:
	void doAdaptation();
	void fileChoose();
	void checkDest();
	void closeMP7();
	void resetDest();
	void updateBitrate();
	void bitrateChange();
protected:
	void loadMP4(QString &file);
	void enableDest();
	void disableDest();

protected:
	ContainerInfo* currentVideo;
	FILE* mp7;
	unsigned int totalSizeSrc;
	unsigned int bBitrateDest;
	unsigned int bBitrateSrc;
};

#endif
