
 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	mohican.cpp                                             *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/


#include "net/HttpServer.hpp"

#include "vitooki.hpp"


void printHelp(const char* name) {
  printf("%s [--rootdir PATH/TO/HTDOCS] [--cgidir /RELATIVEPATH/TO/CGIBIN] [--port NUMBER]\n\n",name);
  printf("Option --rootdir PATH/TO/HTDOCS: where the .html files reside. If omitted, current dir is chosen\n");
  printf("Option --cgidir /RELATIVEPATH/TO/CGIBIN: where the exec-cgi-scripts reside. always added to rootdir, defaults to /cgi-bin/\n");
	printf("Option --port NUMBER:            where to listen for tcp/http requests, defaults to 8080\n");
  
}



int main(int argc, char* argv[]) {
  char *progname = argv[0];
  char *rootdir = ".";
  char *cgidir = "/cgi-bin/";
  int port = 8080;


  while (--argc > 0 && (*++argv)[0] == '-') {
    if (strcmp(*argv, "--rootdir") == 0) {
      rootdir = argv[1];
      --argc;
      ++argv;					
    } else     if (strcmp(*argv, "--cgidir") == 0) {
      cgidir = argv[1];
      --argc;
      ++argv;					
    } else     if (strcmp(*argv, "--port") == 0) {
      port = atoi(argv[1]);
      --argc;
      ++argv;					
    } else {
      printf("Unknown option: %s\n", *argv);
      printHelp(progname);
      exit(1);
    }
  }
  
  if (argc != 0) {
    printHelp(progname);
    exit(1);
  }


  HttpServer *httpsrv = new HttpServer(port,rootdir,cgidir);
  httpsrv->start();
  httpsrv->wait();

  return 0;
}


