 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	JobListCreator.cpp                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "JobListCreator.hpp"
#include <iostream>
JobListCreator::JobListCreator(string url,string basedir,bool recursive)
{
	
	this->url = url;
	string::iterator i=url.end();
	if(*(--i) != '/') {
		this->url+='/';
	}
	this->basedir = basedir;
	this->recursive = recursive;
	knownTypes.push_back(".mp4");
	knownTypes.push_back(".avi");
	knownTypes.push_back(".mp3");
	knownTypes.push_back(".mpeg");
	knownTypes.push_back(".mpg");
}

bool JobListCreator::inKnownTypes(string filename)
{
	for (unsigned int i = 0 ; i < knownTypes.size() ; i++){
		if (filename.find(knownTypes[i]) != string::npos){
			return true;
		}
	}
	return false;
}
void JobListCreator::printJob(string path)
{
	cout << "<Job>\n\turl="<<url<<path<<"\n</Job>\n";
}
void JobListCreator::create()
{
	listDir();
}
void JobListCreator::listDir(string path)
{
	sord::directory* dir = new sord::directory((basedir+path).c_str());
	sord::entry* file;
	string fpath;
	string entry;
	if (path == "./" || path == "."){
		path = "";
	}
	if (!dir){
		cerr << "Failed to open " << basedir <<path<<"\n";
		return;
	}
	sord::directory::const_iterator &i = dir->begin();
        sord::directory::const_iterator &end = dir->end();
	for (; i!= end;++i){
		entry = i->get_name();
		fpath = basedir + path + entry;
		file = new sord::entry(fpath.c_str());
		if (file){
			if (file->get_type() == 2 && recursive == true) {
				listDir(path+entry+"/");
			}
			else {
				if (inKnownTypes(path+entry)){
					printJob(path+entry);
				}
			}
		}
		delete(file);
	}
	delete(dir);
}

