#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream>
#include <string>

#define SERVER_FILE 0
#define CLIENT_FILE 1
#define OTHER_FILE 2
#define SERVER_COLUMNS 16
#define CLIENT_COLUMNS 16

using namespace std;

void usage()
{
	printf("./plotgenerator filename\n");
	exit(0);
}
int get_filetype(char* filename)
{
	if (strstr(filename,"_server.out") != NULL) return SERVER_FILE;
	else if (strstr(filename,"_client.in") != NULL) return CLIENT_FILE;
	else return OTHER_FILE;
}

int get_filets(char* filename)
{
	int toffset;
	char* tsend = strchr(filename,'.');
	#if WIN32
	char* fstart = strrchr(filename,'\\');
	#else
	char* fstart = strrchr(filename,'/');
	#endif
	if (!fstart) fstart = filename;
	else fstart+=1;
	if (!tsend) return 0;
	char* cts = new char[10];
	strncpy(cts,fstart+3,10);
	toffset = atoi(cts);
	delete cts;
	return toffset;
}

void generatePlotFile(char* filename,int offset)
{
	int filetype = get_filetype(filename);
	int num_cols;
	int toffset = offset;	
	if (filetype == 0) num_cols = SERVER_COLUMNS;
	else if(filetype == 1) num_cols = CLIENT_COLUMNS;
	else return;

	char* target = new char[strlen(filename)+5];
	sprintf(target,"%s.plot",filename);
	char* header = "set terminal png\nset key left\nset data style line\nset xlabel \"Playout Second\"\n";

	ofstream fp(target);
	if(fp.is_open()){
		fp << header;
		for (int i = 2; i <= num_cols ; i++){
			fp << "set terminal png\n";
			fp << "set output \"" << filename << "-col_"<< i <<".png\"\n";
			fp << "plot \"" << filename << "\" using ($1-" << toffset <<"):"<< i << " w lines 1\n";
			fp << "set terminal postscript eps enhanced color solid\n";
			fp << "set output \"" << filename << "-col_"<< i <<".eps\"\n";
			fp << "plot \"" << filename << "\" using ($1-" << toffset <<"):"<< i << " w lines 1\n";
		}
		fp.close();
	}
}
int main(int argc,char** argv)
{
	for (int i = 1 ; i < argc ; i++){
		if (strcmp(argv[i],"--help") == 0) usage();
		else generatePlotFile(argv[i],get_filets(argv[i]));
	}
	return 0;
}
