#ifndef PS_PROXY_REQUESTITERATOR
#define PS_PROXY_REQUESTITERATOR
#define MAX_VIDEOS 65536
#define MAX_PERCENT 10
#include "markglobal.hpp"
#include "utils.hpp"
#include "io/DevNull.hpp"
#include "net/ClientSession.hpp"
#include "UserPrefGenerator.hpp"
#include "bmjoblist.hpp"


//#include "CRS.hpp"
struct datentry
{
	uint id;
	uint occurrence;
	uint size;
	void println()
	{
		dprintf_full("[ %u , %u , %u ]\n",id,occurrence,size);
	}
	bool operator<(const datentry other) const
	{
		return this->size < other.size;
	}
};

class RequestIterator
{
public:
	//static RequestIterator* create(const char* videoDescriptionFile, UserPrefGenerator* up, const char* title, const char* outFile);

	~RequestIterator();
	
	void doAll(FILE* jobs, bool rtx);
	RequestIterator(const char* tle, const char* outFile, 
		const char* DescFile, const char* jlFile,UserPrefGenerator* up,const char* proxy=NULL);

	bool readJobEntry(FILE* job, int* id, double* timePoint, int* size);
	
	bool makeRequest(FILE* fp, UserPreferences* &outPointer, Feature* &outParamVid, double &startTimePoint );

	void readDescriptions(FILE* fp);
	void readDescriptions(const char* filename,const char* jlFile);
private:
	Feature* videos[MAX_VIDEOS];
	int nrVideos;
	UserPrefGenerator* pUserPref;
	char* title;
	char* outFileName;
	char* proxy;
};

#endif
