/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   UPContainer.hpp                                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /**********************************************************************
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef UPCONTAINER_HPP
#define UPCONTAINER_HPP
#include <stdio.h>
/** \brief An abstraction class for the UserPrefGenerator config file
 */
class UPContainer
{
	public:
		UPContainer();
		UPContainer(int wmin,int wmax,int fmin,int fmax,int bmin,int bmax,bool retr,int numProbs,int* probs,int nap);
		~UPContainer();
		/** \brief Write config information to the given path */
		bool toFile(char* filename);
		/** \brief Write config information to the given filepointer */
		void toFile(FILE* fp);
		/** \brief Read config information from the given path */
		bool fromFile(const char* filename);
		/** \brief Read config information from the given filepointer */
		void fromFile(FILE* fp);
		
		int vidWidth_min;
		int vidWidth_max;
		int framerate_min;
		int framerate_max;
		int bitrate_min;
		int bitrate_max;
		bool retransmission;
		int num_probs;
		int* probabilities; 
		int non_adaptation_prob;
	private:
		/** \brief strips blanks from head and tail of a string
		  \param string String to be "cleaned"
		 */
		char* strip_spaces(char* string);
};
#endif
