#ifndef PS_PROXY_USERPREFGENERATOR
#define PS_PROXY_USERPREFGENERATOR
#include "utils.hpp"
#include "../../src/metadata/UserPreferences.hpp"

class UserPrefGenerator
{
public:
	/** @param users: array of single features for groups
	  * @param users: array of possibility in promille for each group. Must sum up to 1000-promilleOriginal
	  * @param nrProbClasses: number of different groups, defines the size of the arrays
	  * @param seed: starting seed for pseudonumber generator
	  * @param percentOriginal: how many requests go to the original video? Note that nrProbClasses
	  * only contains requests with UserPreferences. The original one is NOT included!
	  */
	UserPrefGenerator(UserPreferences** groups, const int* probabilities, unsigned int nrProbClasses, int seed, int promilleOriginal);
	/** returns array of pre-generated user classes */
	~UserPrefGenerator();
	static UserPreferences** generateClasses(const Feature& mn, const Feature& mx, int maxClasses);
	/** returns Userprefs. If NULL is returned no adaptation is desired! */
	UserPreferences* makeUserPref();
	/** returns dimension tailored userprefs. If NULL is returned no adaptation is desired! */
	UserPreferences* makeUserPreferences(int dimX,int dimY);
	static void doTest();
private:
	/** returns -1 if the original video should be sent */
	int findClassFor(int val);

private:
	int *probabilities;
	int probClasses;
	int promilleOriginal;
	UserPreferences** ppClasses;
};

#endif

