/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   bm.cpp                                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /**********************************************************************
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "bm.hpp"

Benchmark::Benchmark(const char* re, const char* dat,const char* up,const char* jl)
{
	assert(re);
	assert(dat);
	assert(up);
	assert(jl);
	dprintf_full("\033[35mBenchmark::construct\033[0m\n");
	strcpy(requestFile,re);
	strcpy(datFile,dat);
	strcpy(upFile,up);
	strcpy(jlFile,jl);
	this->session = NULL;
}

Benchmark::~Benchmark()
{
	dprintf_full("\033[35mBenchmark::destruct\033[0m\n");
	if (!this->session)
	{
		delete(this->session);
		this->session=NULL;
	}
}

bool Benchmark::init(const char* proxy)
{
	dprintf_full("\033[35m> Benchmark::init\033[0m\n");
	
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv	
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

	BMJobList* jl = new BMJobList();
	jl->fromConfig(jlFile);
	UPContainer* upc = new UPContainer();
	if ( !upc->fromFile(upFile) )
	{
		printf("ERR: can't open %s for reading\n",upFile);
		return false;
	}

	RequestIterator* myRI = NULL;
	UserPrefGenerator* myUPG = NULL;
	const Feature* minF = NULL;
	const Feature* maxF = NULL;
	const Feature* avgF = NULL;
	// read jobs from list
	const char* uri = "rtsp://127.0.0.1:5554/dummy.mp4";
	// uri = job.getUrl

	// get aspectRatio from VideoEsInfo
	
	//int dimXmin = 176;
	int dimXmin = upc->vidWidth_min;
	float aspR = 1.22f;
	int dimYmin = (int) ( (float)dimXmin / aspR );
	int colD = 1;
	//int bitrate = 85888;
	//int bitrate = 1000;
	int bitrate = upc->bitrate_min*1000;
	// get dimXmin from gui
	int cached = 0;
	// cached = ???
	int cCost = 1;
	// ContentCost  = ???
	//double framerate = 30;
	double framerate = (double)upc->framerate_min;
	double duration = 30;

	printf("==========================X: %i Y: %i B: %i=========================\n",dimXmin , dimYmin, bitrate );
	minF = new Feature( uri, dimXmin, dimYmin, colD , bitrate, cached, cCost, framerate, duration);
	
	// get dimXmax from gui
	//int dimXmax = 352;
	int dimXmax = upc->vidWidth_max; 
	//bitrate = 405504;
	//bitrate = 4000;
	bitrate = upc->bitrate_max*1000;
	
	//framerate = 30;
	framerate =  (double)upc->framerate_max;
	
	int dimYmax = (int) ( (float)dimXmax / aspR );
	
	printf("==========================X: %i Y: %i B: %i=========================\n",dimXmax ,dimYmax ,bitrate );
	maxF = new Feature( uri, dimXmax, dimYmax, colD , bitrate, cached, cCost, framerate, duration);

	int dimXavg = 352;
	//bitrate = 405504;
	bitrate = 4000;
	int dimYavg = (int) ( (float)dimXavg / aspR );
	
	printf("==========================X: %i Y: %i B: %i=========================\n",dimXavg , dimYavg, bitrate );
	avgF = new Feature( uri, dimXavg, dimYavg, colD , bitrate, cached, cCost, framerate, duration);

	//const int proper[] = { 200, 200, 200, 200, 200 };

	//uint tmp = 5;
	//uint tmp2 = 0;

	//myUPG = new UserPrefGenerator( proper, tmp, 1337 , minF, maxF, avgF, tmp2);
	
	printf("\n\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n\n");
	Feature mf=*minF;
	Feature xf=*maxF;
	UserPreferences** ppUp=UserPrefGenerator::generateClasses(mf,xf,upc->num_probs);
	myUPG = new UserPrefGenerator(ppUp,upc->probabilities,upc->num_probs, 1337 ,upc->non_adaptation_prob);
	ppUp=NULL;
	//myUPG = new UserPrefGenerator( upc->probabilities, upc->num_probs, 1337 , minF, maxF, avgF, upc->non_adaptation_prob);
	const char* outfile = "outfile.blob";
	assert(myUPG);
	
	myRI = new RequestIterator( "some title",outfile , datFile, jlFile, myUPG,proxy );

	 printf("\n\n<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n\n");
	dprintf_full("myRI(%p)->doAll\n", myRI);
	
	printf(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>%i<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n", upc->retransmission);
	FILE* fp=fopen(requestFile,"rb");	
	if(fp) {
		myRI->doAll( fp, upc->retransmission );
		fclose(fp);
	}
	else
		printf("ERR: failed to open %s\n",requestFile);
	
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	delete jl;
	delete myRI;
	return true;	
}

bool Benchmark::run()
{
	dprintf_full("\033[35m> Benchmark::running\033[0m\n");
	
//	this->session->run();
	
	dprintf_full("\033[35m< Benchmark::finished\033[0m\n");
	return false;
}

bool Benchmark::wait()
{
	dprintf_full("\033[35mBenchmark::waiting\033[0m\n");
	fflush(stdout);
//	this->session->wait();
	dprintf_full("\033[35mBenchmark::waited\033[0m\n");
	fflush(stdout);
	return false;
}
 
