/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   cg.hpp                                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/


#ifndef _BM_HPP_
#define _BM_HPP_

#include "markglobal.hpp"
#include "bmjoblist.hpp"
#include "RequestIterator.hpp"
#include "UPContainer.hpp"

class Benchmark
{

private:
	char* name;
	char requestFile[MAX_STR_LEN];
	char datFile[MAX_STR_LEN];
	/** user preferences file: .up.conf */
	char upFile[MAX_STR_LEN];
	/** .job.conf */
	char jlFile[MAX_STR_LEN];
	int numClients;
	int delayInMs;
	int parallelity;
//	ClientGroup* cg;
//	UserPreferences* up;
//	BMJob* job;
	ClientSession* session;

public:
	Benchmark(const char* requestFile,const char* datFile,const char* upFile,const char* jlFile);
	~Benchmark();

	bool init(const char* proxy=NULL);
	bool run();
	bool wait();
	
	char* getName();

	//void setGroup( ClientGroup* new_group );

//	void setJob( BMJob* new_job );

	void setNumClients( int numClients );

	void setDelayInMs( int delayInMs );

	void setParallelity( int parallelity );

	int getNumClients();

	int getDelayInMs();

	int getParallelity();

//	ClientGroup* getGroup();

//	BMJob* getJob();

	char* toString( char* buffer, int len);

	bool fromString( char* buffer);
	
};

#endif
