/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   bm_session.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _BM_SESSION_HPP_
#define _BM_SESSION_HPP_

#include "vitooki.hpp"
#include "global.hpp"
#include "metadata/TerminalCapabilities.hpp"
#include "net/PacketizationLayer.hpp"
#include "net/Url.hpp"
#include "adaptors/GlobalTimer.hpp"
#include "net/RFC3016.hpp"
#include "io/Rtp.hpp"
#include "adaptors/MP4Decoder.hpp"
#include "DataChannel.hpp"
#include "net/RTSP.hpp"
#include "ContainerInfo.hpp"
#include "VideoESInfo.hpp"
#include "Statistics.hpp"

#define PLAYER_ID "muvimark"

class BenchmarkSession
{
public:
	BenchmarkSession();	// just for testing
	
	BenchmarkSession(URL* new_url, int new_localport, int new_remoteport=554);
	~BenchmarkSession();

	bool exec();


private:

	Url* url;
	int remoteport;
	struct sockaddr_in sin;
	int sock;
	RTSP* rtsp;
	ContainerInfo* strc;
	VideoESInfo* esi;
	TerminalCapabilities* tc;
	PacketizationLayer* pl;
	GlobalTimer* gt;
	Statistics* stats;
	int localport;
	Rtp* rtp;
	u32 sID;
	bool OK=false;
	DataChannel* dc;
	MP4Decoder* mp4d;

}

#endif
