/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
4** place of a destructor.
*****************************************************************************/
/* TBD: 
   - Make fields r/w for chaning all aspects of a video/audio stream
   */
#include "bmjoblist.hpp"
#include <qmessagebox.h>
#include <assert.h>
void jl_interface2::init()
{

    this->joblist = (void*)new BMJobList();
    this->pb_describe->setEnabled(false);
    this->pb_describeAll->setEnabled(false);
    /* Get BMJobList from file */
    ((BMJobList*)(this->joblist))->fromConfig();
    /* Now fill the listbox */
    //this->lv_joblist->clear();
    this->tab_joblist->setNumRows(0);
    for (unsigned int i = 0 ; i < ((BMJobList*)(this->joblist))->size() ; i++) {
	//this->lv_joblist->insertItem(new QListViewItem(this->lv_joblist,QString::number(i),((BMJobList*)(this->joblist))->getJob(i)->getURL()->toString(),""));
	this->tab_joblist->insertRows(this->tab_joblist->numRows(),1);
	this->tab_joblist->setText(this->tab_joblist->numRows()-1,0,((BMJobList*)(this->joblist))->getJob(i)->getURL()->toString());
    }
    this->pb_describeAll->setEnabled(true);
    //this->pb_describeAll_clicked();
    this->lastRowSelected = -1;
    if (this->tab_joblist->currentRow() < 0){
	this->pb_update->setEnabled(false);
	this->pb_remove->setEnabled(false);
    }
    if (this->tab_joblist->numRows() > 0) {
	this->tab_joblist->setCurrentCell(0,0);
	this->tab_joblist_currentChanged(0,0);
    }

}


void jl_interface2::pb_close_clicked()
{
    ((BMJobList*)joblist)->toConfig();
    this->close();
}


void jl_interface2::pb_remove_clicked()
{
    int currentRow = this->tab_joblist->currentRow();
    if (currentRow < 0){
	QMessageBox::information(this,"Warning","Nothing selected");
	return;
    }
    
    dprintf_full("[jl_interface2] (%i) %s to be removed\n",currentRow,this->tab_joblist->text(currentRow,0).ascii());
    if(!((BMJobList*)joblist)->removeJob(((BMJobList*)joblist)->getJob(currentRow))){
	QMessageBox::information(this,"Error","Failed to remove job");
	return;	
    }
 
    dprintf_full("[jl_interface2] (%i) %s is the new currentItem\n",currentRow,this->tab_joblist->text(currentRow,0).ascii());
    this->tab_joblist->removeRow(currentRow);
    
    if (this->tab_joblist->numRows() == 0) {
	// disable update and remove and describe*
	this->pb_describeAll->setEnabled(false);
	this->pb_describe->setEnabled(false);
	this->pb_remove->setEnabled(false);
	this->pb_remove->setEnabled(false);
	this->pb_update->setEnabled(false);
	this->pb_deleteNAs->setEnabled(false);
    }
}



void jl_interface2::pb_add_clicked()
{
    /* Save sortorder, insert a new element at the end of the table (id-sorted, ASC)
       and restore the old sorting
 */
    if (this->le_url->text().isEmpty()){
	QMessageBox::information( this, "Warning","No URL specified");
	return;
    }
    BMJob* newJob = new BMJob(this->le_url->text().ascii());
    if (newJob->getURL()->getFileName() == NULL){
	QMessageBox::information( this, "Warning","Invalid URL");
	return;
    }
    if (!((BMJobList*)joblist)->addJob(newJob)){
	QMessageBox::information( this, "Error","Adding new job failed.");
	return;	
    }
    int newRow = this->tab_joblist->numRows();
    this->tab_joblist->insertRows(newRow,1);
    this->tab_joblist->setText(newRow,0,this->le_url->text());
    /* If the describe/... buttons are disabled enable them now */
    this->pb_deleteNAs->setEnabled(true);
    this->pb_describeAll->setEnabled(true);
    //this->lv_joblist->insertItem(new QListViewItem(this->lv_joblist,QString::number((((BMJobList*)joblist)->size())-1),this->le_url->text(),""));
}


void jl_interface2::pb_update_clicked()
{
    if (this->le_url->text().isEmpty()){
	QMessageBox::information( this, "Warning","No URL specified");
	return;
    }
    BMJob* newJob = new BMJob(this->le_url->text().ascii());
    if (newJob->getURL()->getFileName() == NULL){
	QMessageBox::information( this, "Warning","Invalid URL");
	return;
    }
    int currentRow = tab_joblist->currentRow();
    if (currentRow < 0){
	QMessageBox::information( this, "Warning","No item selected");
	return;
    }
    if(!((BMJobList*)joblist)->getJob(currentRow)->setURL(this->le_url->text().ascii())){
	QMessageBox::information( this, "Error","Failed to update job");
	return;
    }	
    tab_joblist->setText(currentRow,0,this->le_url->text());   
}


void jl_interface2::pb_reset_clicked()
{
    ((BMJobList*)(this->joblist))->fromConfig();
    /* Now fill the listbox */
    //this->lv_joblist->clear();
    this->tab_joblist->setNumRows(0);
    for (unsigned int i = 0 ; i < ((BMJobList*)(this->joblist))->size() ; i++) {
	//this->lv_joblist->insertItem(new QListViewItem(this->lv_joblist,QString::number(i),((BMJobList*)(this->joblist))->getJob(i)->getURL()->toString(),""));
	this->tab_joblist->insertRows(this->tab_joblist->numRows(),1);
	this->tab_joblist->setText(this->tab_joblist->numRows()-1,0,((BMJobList*)(this->joblist))->getJob(i)->getURL()->toString());
    }
}


void jl_interface2::tab_joblist_currentChanged( int row, int col )
{
    dprintf_full("Current row: %i\n",row);
    if (this->lastRowSelected != row){
	BMJob* currentJob = ((BMJobList*)joblist)->getJob(row);
	dprintf_full("[jl_interface2] URL=%s\n",this->tab_joblist->text(row,0).ascii());
	this->lastRowSelected = row;
	this->le_url->setText(currentJob->getURL()->toString());	
	this->le_videoWidth->setText(QString::number(currentJob->getVideoWidth()));
	this->le_videoHeight->setText(QString::number(currentJob->getVideoHeight()));
	this->le_audioSampleRate->setText(QString::number(currentJob->getAudioSampleRate()));
	this->le_audioChannels->setText(QString::number(currentJob->getAudioChannels()));
	this->le_audioBitrate->setText(QString::number(currentJob->getAudioBitrate()));
	this->le_videoBitrate->setText(QString::number(currentJob->getVideoBitrate()));
	this->pb_update->setEnabled(true);
	this->pb_describe->setEnabled(true);
	this->pb_remove->setEnabled(true);
    }
    col = 0;
}

/**
 * Remove all jobs where describe() has failed from the list and the
 * interface
 */
void jl_interface2::pb_deleteNAs_clicked()
{
    printf("jlinterface2::pb_deleteNAs_clicked()\n");
    BMJob* currentJob;
    std::list<int> jobs;
    jobs.push_back(-1);
    /* Find unavailable jobs */
    for (unsigned int i = 0 ; i < ((BMJobList*)(this->joblist))->size() ; i++) {
	currentJob = ((BMJobList*)(this->joblist))->getJob(i);
	currentJob->describe(true);
	if (!currentJob->isAvailable()){
	    dprintf_full("[jl_interface2] Job %u is not available\n",i);
	    jobs.push_back(i);
	    printf(">>> Job %u is not available <<< \n",i);
	}
    }
    /* ... and remove them but in reverse order*/
    printf("%u job(s) to be removed\n",jobs.size());
    std::list<int>::iterator current = jobs.end();
    current--;
    u32 currentVal;
    while (current != jobs.begin() && *current != -1) {
	currentVal = *current;
	printf("JobNum: %i\n",currentVal);
	this->tab_joblist->removeRow(*current);
	((BMJobList*)this->joblist)->removeJob(((BMJobList*)this->joblist)->getJob(*current));
	current--;
	printf("Job removed. Table should have %u rows left\n",this->tab_joblist->numRows());
    }
    if (this->tab_joblist->numRows() == 0) {
	// disable update and remove and describe*
	this->pb_describeAll->setEnabled(false);
	this->pb_describe->setEnabled(false);
	this->pb_remove->setEnabled(false);
	this->pb_remove->setEnabled(false);
	this->pb_update->setEnabled(false);
	this->pb_deleteNAs->setEnabled(false);
    }
}


void jl_interface2::pb_describe_clicked()
{
    int currentRow = tab_joblist->currentRow();
    if (currentRow < 0){
	QMessageBox::information( this, "Warning","No item selected");
	return;
    }
    BMJob* currentJob = ((BMJobList*)joblist)->getJob(currentRow);
    if (currentJob == NULL){
 	QMessageBox::information( this, "Error","Couldn't fetch job");
	this->tab_joblist->setText(currentRow,1,"N");
	return;
    }
    if(!currentJob->describe(true)){
 	QMessageBox::information( this, "Error","Failed to DESCRIBE job");
	this->tab_joblist->setText(currentRow,1,"N");
	return;	
    }
    /* Update the info fields */
    this->le_videoWidth->setText(QString::number(currentJob->getVideoWidth()));
    this->le_videoHeight->setText(QString::number(currentJob->getVideoHeight()));
    this->le_audioSampleRate->setText(QString::number(currentJob->getAudioSampleRate()));
    this->le_audioChannels->setText(QString::number(currentJob->getAudioChannels()));
    this->le_audioBitrate->setText(QString::number(currentJob->getAudioBitrate()));
    this->le_videoBitrate->setText(QString::number(currentJob->getVideoBitrate()));
    this->tab_joblist->setText(currentRow,1,"Y");
}


void jl_interface2::pb_describeAll_clicked()
{
    if (tab_joblist->numRows() < 1){
 	QMessageBox::information( this, "Warning","There are no jobs to describe");
	return;
    }
    BMJob* currentJob;
    u32 descY = 0;
    u32 descN =0;
    for (unsigned int i = 0 ; i < ((BMJobList*)(this->joblist))->size() ; i++) {
	currentJob = ((BMJobList*)(this->joblist))->getJob(i);
	if (currentJob != NULL) {
	    if(currentJob->describe(true)){
		tab_joblist->setText(i,1,"Y");
		descY++;
	    }
	    else {
		tab_joblist->setText(i,1,"N");
		descN++;
	    }
	}	
    }
    QMessageBox::information( this, "Info",QString::number(descY+descN)+" described:\n"+QString::number(descY)+" available");    
}
