/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qmessagebox.h>
#include <qlistview.h>
#include "UPContainer.hpp"
#define PROB_COL 0
#include <stdlib.h>

void UPGUI::init()
{
    this->lastNumUPs = this->numPrefs->value();
    this->probList->setColumnWidth(PROB_COL,this->probList->geometry().width()-2);
    this->probList->setColumnWidthMode(PROB_COL,QListView::Maximum);
    this->sbProb->setEnabled(false);
    UPContainer* container = new UPContainer();
    /* Load the values from the config file */
    container->fromFile((const char*)".up.conf");
    this->widthMin->setValue(container->vidWidth_min);
    this->widthMax->setValue(container->vidWidth_max);
    this->fpsMin->setValue(container->framerate_min);
    this->fpsMax->setValue(container->framerate_max);
    this->bitrateMin->setValue(container->bitrate_min);
    this->bitrateMax->setValue(container->bitrate_max);
    this->numPrefs->setValue(container->num_probs);
    this->nap->setValue(container->non_adaptation_prob);
    int j = 0;
    for (QListViewItemIterator i(this->probList) ; i.current() && j<container->num_probs ; i++){
	i.current()->setText(PROB_COL,QString::number(container->probabilities[j]));
	j++;
    }
    /* For writing back we will use another container */
    delete(container); 
}
void UPGUI::numUPChanged( int newnum )
{
    if (newnum > this->lastNumUPs){
	printf("Incremented\n");
	/* Add a new row to the table */
	while(this->probList->childCount() < newnum) {
	    this->probList->insertItem(new QListViewItem(this->probList,"0"));
	}
    }
    else {
	printf("Decremented\n");
	/* Remove the last row from the table */
	while(this->probList->childCount() > newnum){
	    this->probList->takeItem(this->probList->lastItem());
	}
    }
    //this->upProbs->setNumRows(newnum);
    this->sbProb->setEnabled(((newnum>0)?true:false));
    printf("%i\n",newnum);
    this->lastNumUPs = newnum;
}





void UPGUI::okClicked()
{
    /* Make sure that that sum(probabilities) <= 1000 */
    //int col = 0;
    //int rows = this->upProbs->numRows();
    int sum = 0;
    /*for (int i = 0 ; i < rows ; i++){
	sum += this->upProbs->text(i,col).toInt();
	if ( sum>1000 || sum<0 ) {
	    QMessageBox::critical(this,"Invalid probabilities","Probabilities too high or too low");
	    return;
	}
    }*/
    int* tmpArray = (int*)malloc(sizeof(int)*this->numPrefs->text().toInt());
    int j=0;
    for (QListViewItemIterator i(this->probList) ; i.current() ; i++){
	sum+=i.current()->text(PROB_COL).toInt();
	if (sum > 1000 || sum < 0) {
	    QMessageBox::critical(this,"Invalid probabilities","Probabilities too high or too low");
	    delete(tmpArray);
	    return;	    
	}
	tmpArray[j++]=i.current()->text(PROB_COL).toInt();
	printf("> %i\n",i.current()->text(PROB_COL).toInt());
    }
    /* Check video width */
    if (widthMin->value() > widthMax->value()){
	QMessageBox::critical(this,"Invalid video width parameters","Max < Min :-?");
	    delete(tmpArray);
	    return;
    }
    if (fpsMin->value() > fpsMax->value()){
	QMessageBox::critical(this,"Invalid framerate","Max < Min :-?");
	    delete(tmpArray);
	    return;
    }
    if (bitrateMin->value() > bitrateMax->value()){
	QMessageBox::critical(this,"Invalid bitrate","Max < Min :-?");	
	    delete(tmpArray);
	    return;
    }

    printf("%i\n",sum);

    
    /* If everything is ok, then create a new UPContainer for output */
    UPContainer* container = new UPContainer(this->widthMin->text().toInt(),
					     this->widthMax->text().toInt(),
					     this->fpsMin->text().toInt(),
					     this->fpsMax->text().toInt(),
					     this->bitrateMin->text().toInt(),
					     this->bitrateMax->text().toInt(),
					     this->retransmission->isChecked(),
					     this->numPrefs->text().toInt(),
					     tmpArray,
					     this->nap->text().toInt()
					     );
    container->toFile(".up.conf");
    delete(container);
}


void UPGUI::updateSbProb( QListViewItem * i )
{
    if (i){
	/* Load the probability value into sbProb */
	printf("Hall: %s\n",i->text(PROB_COL).ascii());
	this->sbProb->setValue(i->text(PROB_COL).toInt());
    }
}


void UPGUI::sbProb_valueChanged( int newVal )
{
    /* Update the currently selected listitem */
    this->probList->currentItem()->setText(PROB_COL,(const QString&)QString::number(newVal));
}
