/***********************************************************************
 *                                                                      *
 * MuViNo - ViTooKi Video Annotation Tool                               *
 *                                                                      *
 * title:	cretioninformation.cpp                                  *
 *                                                                      *
 * $Id: uri.cpp,v 1.3 2006/03/08 08:17:30 mkropfbe Exp $
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

#include <qcombobox.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qstring.h>
#include <qfiledialog.h>
#include <qaction.h>
#include <qvariant.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include "uri.hpp"

#include "debug.hpp"

Uri::Uri(QWidget *parent, const char *name, bool modal, WFlags f)
  : UriDlg(parent, name, modal, f)
{
    // signals and slots connections
    connect( videoFileButton, SIGNAL( clicked() ), this, SLOT( fileVideoUri() ) );
    connect( audioFileButton, SIGNAL( clicked() ), this, SLOT( fileAudioUri() ) );
}

void Uri::fileVideoUri()
{
  fileVideoUri(QString::null);
}

void Uri::fileVideoUri(const QString &path)
{
  QString s(path);
  if (s.isEmpty())
    s = QFileDialog::getOpenFileName(".", "Videos (*.mp4 *.avi)",
				     this, "video uri dialog",
				     "video uri");
  if (!s.isEmpty()) 
  	videoUriEdit->setText(s);
	  	     
}

void Uri::fileAudioUri()
{
  fileAudioUri(QString::null);
}

void Uri::fileAudioUri(const QString &path)
{
  QString s(path);
  if (s.isEmpty())
    s = QFileDialog::getOpenFileName(".", "Soundtrack (*.mp3)",
				     this, "audio uri dialog",
				     "audio uri");
  if (!s.isEmpty()) 
  	audioUriEdit->setText(s);
	  	     
}

