/***********************************************************************
 *                                                                      *
 * MuViNo - ViTooKi Video Annotation Tool                               *
 *                                                                      *
 * title:	variation.hpp                                  *
 *                                                                      *
 * $Id: variation.hpp,v 1.4 2006/03/08 08:17:30 mkropfbe Exp $
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/
 
#ifndef _VARIATION_HPP_
#define _VARIATION_HPP_

/** @file
 * Declaration of the variation class.
 */

#include "variationdlg.hpp"

/** This class implements the (simple) application logic of VariationDlg,
 * the GUI dialog for editing the content-variation descriptors of a video.
 * @author Armin Mueller
 * @version $Id: variation.hpp,v 1.4 2006/03/08 08:17:30 mkropfbe Exp $
 */

class Variation : public VariationDlg
{
public:
  /** Constructor. */
  Variation(QWidget *parent = 0, const char *name = 0,
	       bool modal = false, WFlags f = 0);
public slots:
  virtual void fileBitrateVideoUri();
  virtual void fileBitrateVideoUri(const QString &path); 
  virtual void fileResolutionVideoUri();
  virtual void fileResolutionVideoUri(const QString &path);
  virtual void fileColorVideoUri();
  virtual void fileColorVideoUri(const QString &path);  
 


  
};

 
#endif
