 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	GlobalOptionsimpl.cpp                                         *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "GlobalOptionsImpl.hpp"
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qfiledialog.h>
#include <iostream>
#include "global.hpp"

/* 
 *  Constructs a GlobalOptions which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
GlobalOptions::GlobalOptions( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : GlobalOptionsBase( parent, name, modal, fl )
{
	lineEditLocalDirectory->setText("c:/mpeg4itec/test");
	checkBoxProxy->setChecked(false);
	lineEditProxyName->setEnabled(false);
	spinBoxProxyPort->setValue(3128);
	spinBoxProxyPort->setEnabled(false);

}

/*  
 *  Destroys the object and frees any allocated resources
 */
GlobalOptions::~GlobalOptions()
{
    // no need to delete child widgets, Qt does it all for us
}


void GlobalOptions::browse_Directories() {
	QString dn = QFileDialog::getExistingDirectory ( "c:/", 0, 0, "Browse Directory",false ) ;
	if(!dn.isEmpty()) {
		lineEditLocalDirectory->setText(dn.latin1());
			dprintf_full("DIR = %s\n",dn.latin1());
	}


}
void GlobalOptions::enableDisableProxyOptions() {
	if(checkBoxProxy->isChecked()) {
		lineEditProxyName->setEnabled(true);
		spinBoxProxyPort->setEnabled(true);
	}
	else {
		lineEditProxyName->setEnabled(false);
		spinBoxProxyPort->setEnabled(false);
	}
}
