 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	ProfileParser.cpp                                             *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "ProfileParser.hpp"
#include <fstream>
#include <qstring.h>

ProfileParser::ProfileParser() {
}

ProfileParser::~ProfileParser() {
}

char * ProfileParser::parseNextLine(FILE * fp) {
	char * nextLine = new char[100];
	fgets(nextLine,100,fp);
	int i = strlen(nextLine);
	
	int k = 0;
	while((k<i) && ((nextLine[0] == ' ') ||(nextLine[0] == '\t'))) {
		cout << "in WHILE" << endl;
		k++;
		nextLine++; // = ++nextLine;
	}
	if ((nextLine[0] == '\n') || (nextLine[0] == '#')) 
		return NULL;
	cout << nextLine << endl;
	i = strlen(nextLine);
	
	if(nextLine[i-1] == '\n') {
		nextLine[i-1] = '\0';
	}
	i-=2;
	while((nextLine[i] == ' ') || (nextLine[i] == '\t')) {
		nextLine[i] = '\0';
		i--;
	}
	
	return nextLine;
}

int ProfileParser::parseFromConfigFile(const char * configFile) {
 bool presURIset = false;
 bool parseErrors = false;
 bool local = false;
 int lineCounter = 0;
 FILE * fp = NULL;
 ofstream fperr;
    fp = fopen(configFile,"r");
	if(fp == NULL) {
		dprintf_err("ProfileParser::parseFromConfigFile -> file not found\n");
		return -1;
	}
	fperr.open("parseError.log",fstream::out | fstream::trunc);
	if(!fperr.is_open()) {
		return -1;
	}
	char * nextLine;
	cout << "in method" << endl;
	while(!feof(fp)) {
		lineCounter++;
		nextLine = parseNextLine(fp);
		if(nextLine == NULL)
				continue;
		if((strcmp(nextLine,"<PRESENTATION>") == 0) && presURIset) {
				dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: EOF - </PRESENTATION> not set\n",lineCounter);
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": </PRESENTATION> not set" <<endl;
				parseErrors = true;
		}
		if((strcmp(nextLine,"<PRESENTATION>") == 0) && !presURIset) {
			cout << "BEGIN PRESENTATION" << endl;
			profile = new Profile();
			nextLine = parseNextLine(fp);
			lineCounter++;
			while((nextLine == NULL) && !feof(fp)) {
				lineCounter++;
				nextLine = parseNextLine(fp);
				if(strcmp(nextLine,"<ADAPTORS>") == 0) {
					dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: URI not set\n",lineCounter);
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": URI not set" <<endl;
					parseErrors = true;
				}
				if(strcmp(nextLine,"</ADAPTORS>") == 0) {
					dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: URI not set\n",lineCounter);
					dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: <ADAPTORS> not set\n",lineCounter);
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": URI not set" <<endl;
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": <ADAPTORS> not set" <<endl;
					parseErrors = true;
				}
				if(strcmp(nextLine,"</PRESENATATION>") == 0) {
					dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: URI not set\n",lineCounter);
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": URI not set" <<endl;
					parseErrors = true;
				}
			}

			if(feof(fp) && !presURIset) {
				dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: EOF - <PRESENTATION> not set\n",lineCounter);
				dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: EOF - URI not set\n",lineCounter);
				dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: EOF - </PRESENTATION> not set\n",lineCounter);
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": <PRESENTATION> not set" <<endl;
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": URI not set" <<endl;
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": <PRESENTATION> not set" <<endl;
				parseErrors = true;
				//fclose(fp);
				//fperr.close();
				//return -1;
			}
			if(feof(fp)) {
				dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: EOF - URI not set\n",lineCounter);
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": EOF - URI not set" <<endl;
				parseErrors = true;
			}
			if (strncmp(nextLine,"file://",7) == 0) {
				local = true;
				profile->localPres = true;
				nextLine+=7;
			}
			else 
				if (strncmp(nextLine,"rtsp://",7) == 0) {
					local = false;
					profile->localPres = false;
				}
				else {
					dprintf_err("ProfileParser::parseFromConfigFile -> Line %i: invalid URI set\n",lineCounter);
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": invalid URI set" <<endl;
					parseErrors = true;
				}

			profile->uri = nextLine;
			presURIset = true;

		}
		/* parsed local presentation 
		*/
		if(local) {
			if(strcmp(nextLine,"<ADAPTORS>") == 0) {
				while((strcmp(nextLine,"</ADAPTORS>") != 0) && (!feof(fp))) {
					lineCounter++;
					nextLine = parseNextLine(fp);
					if(strcmp(nextLine,"</ADAPTORS>") == 0)
						continue;
					if(nextLine == NULL)
						continue;	
					if(strcmp(nextLine,"offline") == 0) {
						profile->dummyAdaptors = true;
						continue;
					}
					//look for wrong input structure
					if(strcmp(nextLine,"</PRESENTATION>") == 0) {
						dprintf_err("ProfileParser::parseFromConfigFile -> </ADAPTORS> not set\n");
						fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": </ADAPTORS> not set" <<endl;
						parseErrors = true;
					}
					QString * adp = new QString(nextLine);
					profile->adaptors.push_back(*adp);

				}
				if(feof(fp)) {
					dprintf_err("ProfileParser::parseFromConfigFile -> EOF - </ADAPTORS> not set\n");
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": EOF - </ADAPTORS> not set" <<endl;
					parseErrors = true;
				}
			}
			if((strcmp(nextLine,"</PRESENTATION>") == 0) && !presURIset) {
				dprintf_full("ProfileParser::parseFromConfigFile -> <PRESENTATION> not set\n");
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": <PRESENTATION> not set" <<endl;
				cout << "error" << endl;
				parseErrors = true;
			}
			if((strcmp(nextLine,"</PRESENTATION>") == 0) && presURIset) {
				profileList.push_back(profile);
				presURIset = false;
			}
		} // end if(local)

		/* parsed remote presentation
		*/
		else {
			if(strcmp(nextLine,"<TERMINALCAPS>") == 0) {
				while((strcmp(nextLine,"</TERMINALCAPS>") != 0) && (!feof(fp))) {
					lineCounter++;
					nextLine = parseNextLine(fp);
					if(strcmp(nextLine,"</TERMINALCAPS>") == 0)
						continue;
					if(nextLine == NULL)
						continue;	
					if(strcmp(nextLine,"</PRESENTATION>") == 0) {
						dprintf_err("ProfileParser::parseFromConfigFile -> </TERMINALCAPS> not set\n");
						fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": </TERMINALCAPS> not set" <<endl;
						parseErrors = true;
					
					}
					if(strncmp(nextLine,"ColorDisplay",12) == 0) {
						nextLine+=13;
						if(strncmp(nextLine,"TRUE",4) == 0) {
							profile->termCaps->setColorDisplay(true);
						}
						else {
							profile->termCaps->setColorDisplay(false);
						}
					}
					if(strncmp(nextLine,"Rtx",3) == 0) {
						nextLine+=4;
						if(strncmp(nextLine,"TRUE",4) == 0) {
							profile->rtxEnabled = true;
						}
						else {
							profile->rtxEnabled = false;
						}
					}
					if(strncmp(nextLine,"Dimension",9) == 0) {
						nextLine = parseNextLine(fp);
						u32 value = atoi(nextLine);
						if((value > 64) && (value < 705))
							profile->termCaps->setDisplayWidth(value);
						nextLine = parseNextLine(fp);
						value = atoi(nextLine);
						if((value > 64) && (value < 577))
							profile->termCaps->setDisplayHeight(value);
					}
					if(strncmp(nextLine,"Bandwidth",9) == 0) {
						nextLine = parseNextLine(fp);
						u32 value = atoi(nextLine);
						if((value > 10240 ) && (value < 262145)) {
							profile->termCaps->setNetworkCapacityInByte(value);
							profile->termCaps->setMinGuaranteedNetworkCapacityInByte(value-240);
						}
					}
				}
				if(feof(fp)) {
					dprintf_err("ProfileParser::parseFromConfigFile -> EOF - </TERMINALCAPS> not set\n");
					fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": EOF - </TERMINALCAPS> not set" <<endl;
					parseErrors = true;
				}
			}
			if((strcmp(nextLine,"</PRESENTATION>") == 0) && !presURIset) {
				dprintf_full("ProfileParser::parseFromConfigFile -> <PRESENTATION> not set\n");
				fperr << "ProfileParser::parseFromConfigFile -> Line " << lineCounter <<": <PRESENTATION> not set" <<endl;
				cout << "error" << endl;
				parseErrors = true;
			}
			if((strcmp(nextLine,"</PRESENTATION>") == 0) && presURIset) {
				profileList.push_back(profile);
				presURIset = false;
			}

		}
	}
	fclose(fp);
	fperr.close();
	if(parseErrors) {
		return -1;
	}
	return 0;

}

int ProfileParser::saveConfigToFile(const char * configFile,list <Profile *> profiles) {

	ofstream fp;
	fp.open(configFile,fstream::out | fstream::trunc);
	if(!fp.is_open()) {
		return -1;
	}
	fp << "# A new profile configuration" << endl;
	fp << endl;
	fp << endl;
	for(list <Profile*>::iterator pI = profiles.begin(); pI != profiles.end(); pI++) {
		fp << "<PRESENTATION>" << endl;
	//	cout << (*pI)->uri << endl;
		if (strncmp((*pI)->uri,"rtsp://",7) != 0) {
			QString * tempURI = new QString((*pI)->uri);
			tempURI->prepend("file://");
			fp << "	" << tempURI->latin1() << endl;
		}
		else
			fp << "	" << (*pI)->uri << endl;

		if(!(*pI)->adaptors.empty()) {
			fp << "	<ADAPTORS>" << endl;
			if((*pI)->dummyAdaptors) {
				fp << "		 offline" << endl;
			}
			for(list <QString>::iterator aI = (*pI)->adaptors.begin(); aI != (*pI)->adaptors.end(); aI++) {
				fp << "		" << (*aI).latin1() << endl;
			}
			fp << "	</ADAPTORS>" << endl;
		}
		if((*pI)->termCaps != NULL) {
			fp << "	<TERMINALCAPS>" << endl;
			fp << "		 ColorDisplay ";
			if((*pI)->termCaps->getColorDisplay()) {
				fp << "TRUE" << endl;
			}
			else {
				fp << "FALSE" << endl;
			}
			fp << "		 Rtx ";
			if((*pI)->rtxEnabled) {
				fp << "TRUE" << endl;
			}
			else {
				fp << "FALSE" << endl;
			}
			fp << "		 Dimension" << endl;
			fp << "		 " << (*pI)->termCaps->getDisplayWidth() << endl;
			fp << "		 " << (*pI)->termCaps->getDisplayHeight() << endl;
			fp << "		 Bandwidth" << endl;
			fp << "		 " << (*pI)->termCaps->getNetworkCapacityInByte() << endl;
			fp << "	</TERMINALCAPS>" << endl;
		}

		fp << "</PRESENTATION>" << endl;
		fp << endl;
	}
	fp.close();
	return 0;
}

list <Profile *> ProfileParser::getProfile() {
	return profileList;
}
