 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	PropertiesTab.hpp                                             *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PROPERTIESTAB_HPP_
#define _PROPERTIESTAB_HPP_


class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QGroupBox;
class QLabel;
class QPushButton;
class QTabWidget;
class QProgressBar;
#include <qwidget.h>


/**
 *
 * <Class Description goes here>
 *
 *@author Ronald Sowa
 *
 *@version $Id: PropertiesTab.hpp,v 1.3 2004/02/25 16:02:56 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class PropertiesTab : public QWidget {

public:
	PropertiesTab(QWidget * parent=0, const char * name=0, WFlags f=0 ) ;
	~PropertiesTab();

       QGroupBox* adaptorTermCapBox;
    QLabel* fourLabel;
    QLabel* adaptorLabel4;
    QLabel* adaptorLabel1;
    QLabel* oneLabel;
    QLabel* twoLabel;
    QLabel* adaptorLabel2;
    QLabel* fiveLabel;
    QLabel* adaptorLabel5;
    QLabel* threeLabel;
    QLabel* adaptorLabel3;
    QGroupBox* termCapsBox;
    QLabel* colorLabel;
    QLabel* valueColorDisplay;
    QLabel* labelRtx;
    QLabel* valueRtx;
    QLabel* labelDimension;
    QLabel* valueDimension;
    QLabel* labelBandwidth;
    QLabel* valueBandwidth;
    QLabel* audioESLabel;
    QLabel* valueAES;
    QLabel* videoESLabel;
    QLabel* valueVES;
    QLabel* LabelTotWidth;
    QLabel* valueTotWidth;
    QLabel* LabelTotHeight;
    QLabel* valueTotHeight;
    QLabel* LabelPresNumber;
    QLabel* presNum;
    QLabel* LabelLocalRemote;
    QLabel* LabelURL;
    QLabel* urlText;
    QWidget* tab_2;
    QGroupBox* bufferGroupBox;
    QLabel* bufferBytesLabel;
    QLabel* bufferSecsLabel;
    QProgressBar* bufferProgressBar;
    QLabel* origDimension;
    QLabel* actDimension;
    QLabel* origY;
    QLabel* origX;
    QLabel* actY;
    QLabel* dynDurationValue;
    QLabel* duration;
    QLabel* actX;
    QLabel* abw1;
    QLabel* fiveSec;
    QLabel* abw2;
    QLabel* abw3;
    QLabel* origLabel;
    QLabel* oneSec;
    QLabel* abwOrig;
    QLabel* abwTitle;
    QLabel* fps3;
    QLabel* fps1;
    QLabel* fpsOrig;
    QLabel* fpsTitle;
    QLabel* fps2;
    QLabel* tenSec;
	int durationMS;

protected:
    QGridLayout* PropertiesBaseLayout;
    QHBoxLayout* Layout21;
    QGridLayout* Layout16;
    QHBoxLayout* Layout14;
    QGridLayout* Layout11;
    QGridLayout* Layout12;
    QHBoxLayout* Layout15;
    QHBoxLayout* Layout13;
    QGridLayout* termCapsBoxLayout;
    QVBoxLayout* Layout40;
    QHBoxLayout* Layout34;
    QHBoxLayout* Layout35;
    QHBoxLayout* Layout38;
    QHBoxLayout* Layout39;
    QHBoxLayout* Layout64;
    QHBoxLayout* Layout65;
    QHBoxLayout* Layout66;
    QHBoxLayout* Layout73;
    QHBoxLayout* Layout74;
    QGridLayout* Layout26;
    QGridLayout* bufferGroupBoxLayout;
    QVBoxLayout* Layout21_2;
    QGridLayout* Layout37;
    QGridLayout* Layout61;
  

};
#endif
