 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: ReceiverThread.cpp                                            *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/


#include "ReceiverThread.hpp"

/***********************************************************************/
ReceiverThread::ReceiverThread(RemotePresentation *rp)
{
  this->active = true;
  this->rp = rp;
}

/***********************************************************************/
ReceiverThread::~ReceiverThread()
{
	active = false;
	cout << "ReceiverThread::~ReceiverThread():" << endl;
}

/***********************************************************************/
void ReceiverThread::run()
{

	char buffer[MSG_BUFFER_SIZE];
//	char **buffer = (char**) malloc(sizeof(char));
	int bytesRead;
	while (active) {

		if (rp != NULL && active) {
			rp->receiveMessage();
			if (rp->lookForMessage("ANNOUNCE", buffer, bytesRead)) {
				rp->handleAnnounce(buffer);
			}
			else if (rp->lookForMessage("GET_PARAMETER", buffer, bytesRead)) {
				rp->handleGetParameter(buffer);
			}
			else if (rp->lookForMessage("OPTIONS", buffer, bytesRead)) {
				rp->handleOptions(buffer);
			}
			else if (rp->lookForMessage("SET_PARAMETER", buffer, bytesRead)) {
				rp->handleSetParameter(buffer);
			}
			else if (rp->lookForMessage("REDIRECT", buffer, bytesRead)) {
				rp->handleRedirect(buffer);
			}
			else if (rp->lookForMessage("TEARDOWN", buffer, bytesRead)) {
				rp->handleTeardown(buffer);
			}

			msleep(WAIT_MSECS_ON_RECEIVE);

		} else {
			active = false;
		}
	}

	cout << "ReceiverThread::run(): exit" << endl;
 	this->exit();
}

/***********************************************************************/
bool ReceiverThread::isActive()
{
	return this->active;
}

/***********************************************************************/
void ReceiverThread::deactivate()
{
	this->active = false;
}
