 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	SpatialDialogBaseimpl.cpp                                     *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "SpatialDialogBaseImpl.hpp"
#include "qspinbox.h"

/* 
 *  Constructs a SpatialDialogBase which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
SpatialDialogBase::SpatialDialogBase( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : SpatialDialog( parent, name, modal, fl )
{
	w = 176;
	h = 144;
	dimX->setEnabled(false);
	dimY->setEnabled(false);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
SpatialDialogBase::~SpatialDialogBase()
{
    // no need to delete child widgets, Qt does it all for us
}

void SpatialDialogBase::setUserDefined() {
	dimX->setEnabled(true);
	dimY->setEnabled(true);
}

void SpatialDialogBase::setSD() {
	w = 704;
	h = 576;
	dimX->setEnabled(false);
	dimY->setEnabled(false);
}
void SpatialDialogBase::setCIF() {
	w = 352;
	h = 288;
	dimX->setEnabled(false);
	dimY->setEnabled(false);
}

void SpatialDialogBase::setQCIF() {
	w = 176;
	h = 144;
	dimX->setEnabled(false);
	dimY->setEnabled(false);
}

void SpatialDialogBase::setDimX() {
	w = (dimX->text()).toInt();

}
void SpatialDialogBase::setDimY() {
	h = (dimY->text()).toInt();
}
