 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	TermCapsImpl.cpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "TermCapsImpl.hpp"

#include "SpatialDialogBaseImpl.hpp"
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <iostream>
using namespace std;

TermCapsImpl::TermCapsImpl( QWidget* parent, const char* name, bool modal, WFlags f )
	: LocalAdaptation( parent, name, modal, f )
{
	windowResize = false;
	buttonApply->setEnabled(false);

}

void TermCapsImpl::setActiveAdaptors(list <QString> adaptors) {
	for(list <QString>::iterator aI = adaptors.begin(); aI != adaptors.end(); aI++) {
		activeAdaptors->insertItem((*aI));
		availableAdaptors->removeItem(availableAdaptors->index(availableAdaptors->findItem((*aI))));
		if((*aI).compare("Spatial Adaptation") == 0) {
			    aI++;
				dimensionX = (*aI).toInt();
				aI++;
				dimensionY = (*aI).toInt();
		}
	}



}


void TermCapsImpl::activateAdaptor() {

	int index = availableAdaptors->currentItem();
	
	if ( index != -1) {
		if(availableAdaptors->text(index).compare("Spatial Adaptation") == 0) {
			SpatialDialogBase  spat(this,"Set Dimension",true);
			if(ofCheckBox->isChecked()) {
				spat.RadioButton8->setEnabled(false);
			}
			spat.exec();
			if(spat.result() == Accepted) {
				
				dimensionX = spat.w;
				dimensionY = spat.h;
			
				windowResize = true;
			}
			else 
				return;
		}
		activeAdaptors->insertItem(availableAdaptors->text(index));
		availableAdaptors->removeItem(index);
	buttonApply->setEnabled(true);
	}
}

void TermCapsImpl::deactivateAdaptor() {
	int index = activeAdaptors->currentItem();
	if ( index != -1) {
		if (activeAdaptors->text(index).compare("Spatial Adaptation") == 0) {
			windowResize = true;
		}
		availableAdaptors->insertItem(activeAdaptors->text(index));
		activeAdaptors->removeItem(index);
	buttonApply->setEnabled(true);
	}
}

void TermCapsImpl::moveUpAdaptor() {
	int index = activeAdaptors->currentItem();
	if(index > 0) {
		buttonApply->setEnabled(true);
		QString adaptorText = activeAdaptors->text(index);
		activeAdaptors->removeItem(activeAdaptors->currentItem());
		activeAdaptors->insertItem(adaptorText,index-1);
		activeAdaptors->setSelected(index-1,true);
	}
}

void TermCapsImpl::moveDownAdaptor() {
	int index = activeAdaptors->currentItem();
	if (index < activeAdaptors->numItemsVisible()-1) {
		buttonApply->setEnabled(true);
		QString adaptorText = activeAdaptors->text(index);
		activeAdaptors->removeItem(activeAdaptors->currentItem());
		activeAdaptors->insertItem(adaptorText,index+1);
		activeAdaptors->setSelected(index+1,true);
	}
}

