 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	TermCapsImpl.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef TermCapsImpl_hpp
#define TermCapsImpl_hpp
#include "global.hpp"
#include <list>
#include "TermCaps.hpp"
#include <qstring.h>



/**
 *
 * <Class Description goes here>
 *
 *@author Ronald Sowa
 *
 *@version $Id: TermCapsImpl.hpp,v 1.2 2004/01/09 11:46:59 coderun Exp $
 *
 *@short <short description>
 *
 */
class TermCapsImpl : public LocalAdaptation
{
	Q_OBJECT
public:
	TermCapsImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags f = 0 );

	int getDimensionX() {
		return dimensionX;
	};
	int getDimensionY() {
		return dimensionY;
	};
	void setActiveAdaptors(list <QString> adaptors);

	bool mustWindowResize() {
		return windowResize;
	};
public slots:
	 void activateAdaptor();
	 void deactivateAdaptor();
	 void moveUpAdaptor();
	 void moveDownAdaptor();

private: 
	int dimensionX;
	int dimensionY;
	bool windowResize;
};

#endif
