 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	TermCapsRemoteImpl.hpp                                        *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef TERMCAPSREMOTE_H
#define TERMCAPSREMOTE_H

#include <qcheckbox.h>

#include "TermCapsRemote.hpp"
#include "metadata/TerminalCapabilities.hpp"


/**
 *
 * <Class Description goes here>
 *
 *@author Ronald Sowa
 *
 *@version $Id: TermCapsRemoteImpl.hpp,v 1.5 2004/09/20 09:40:29 mtaschwer Exp $
 *
 *@short <short description>
 *
 */
class TermCapsRemote : public TermCapsRemoteBase
{ 
    Q_OBJECT

public:
        TermCapsRemote( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
        ~TermCapsRemote();
	int getVideoWidth() const {
		return videoWidth;
	}
	int getVideoHeight() const {
		return videoHeight;
	}
	bool getRtxEnabled() const {
		return rtxEnabled;
	}

	bool getColorEnabled() const {
		return colorEnabled;
	}
        u8 getNumAudioChannels() const {
	  return audioCheckBox->isChecked() ? 2 : 0;
	}
        void setTermcapsOfPresentation(TerminalCapabilities * termCaps,bool rtxEnabled, 
				       bool upscale, bool keepAspect, bool enableSwitching);
public slots:
	void set_val(int);
	void setPAL();
	void setCIF();
	void setQCIF();
	void setUserDefinedX();
	void setUserDefinedY();
	void enableDimXY();
	void setRTX();
	void setColorDisplay();
	
private:
	int videoWidth;
	int videoHeight;
	bool rtxEnabled;
	bool colorEnabled;
protected:
	void initMenuBar();
};

#endif // TERMCAPSREMOTE_H
