 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	VideoWindow.cpp                                               *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "VideoWindow.hpp"


VideoWindow::VideoWindow() {

}

VideoWindow::~VideoWindow() {
}


void VideoWindow::switchToFullscreen() {



	for(list <Presentation *>::iterator pres = aPres.begin(); pres != aPres.end(); pres++) {
	//	if(!(*pres)->isActive())
			(*pres)->mute((*pres)->getSessionKey(),false,true);
	}

	for(list <Presentation *>::iterator Ipres = aPres.begin(); Ipres != aPres.end(); Ipres++) {
		if((*Ipres)->isActive()) {
		
			int realHeight = (*Ipres)->getPresentationHeight()-4;
			int realWidth = (*Ipres)->getPresentationWidth()-4;

			/* make best match for fullscreen */
			int resizeHeight = (int) floor(realHeight*((float)320/(float)realWidth));
			(*Ipres)->resizePresentation(320,resizeHeight);
			(*Ipres)->setPresentationPosition(0,0);
			(*Ipres)->movePresentation();
			(*Ipres)->redrawPresentation(0);
			(*Ipres)->unmute((*Ipres)->getSessionKey(),false,true);
			break;
		}
	}
	SDL_ShowCursor(SDL_DISABLE);
	if(SDL_MUSTLOCK(GetScreen())) {
		LockScreen();
	}
		dprintf_full("VideoWindow::switchToFullscreen -> switching now!\n");
		//		InitScreen(320,240,16, SDL_ANYFORMAT | SDL_HWSURFACE | SDL_FULLSCREEN);
		InitScreen(320,240,16, SDL_ANYFORMAT | SDL_SWSURFACE | SDL_FULLSCREEN);
		dprintf_full("VideoWindow::switchToFullscreen -> switching done!\n");

	if(SDL_MUSTLOCK(GetScreen())) {
		UnlockScreen();
	}
/*	for(list <Presentation *>::iterator Fpres = aPres.begin(); Fpres != aPres.end(); Fpres++) {
		if((*Fpres)->isActive()) {
			(*Fpres)->movePresentation();
			(*Fpres)->redrawPresentation(0);
	//		(*Ipres)->unmute((*Ipres)->getSessionKey(),true);
			break;
		}
	}
*/
	bool presPlaying = true;
	SDL_Event event;
 //   SDL_EventState (SDL_ACTIVEEVENT, SDL_IGNORE);
    SDL_EventState (SDL_MOUSEMOTION, SDL_IGNORE);
	SDL_EventState (SDL_MOUSEBUTTONDOWN, SDL_IGNORE);
	SDL_EventState (SDL_MOUSEBUTTONUP, SDL_IGNORE);
	SDL_EventState (SDL_KEYUP, SDL_IGNORE);
	SDL_EventState (SDL_KEYDOWN, SDL_ENABLE);


	SDL_EnableKeyRepeat(0, 0);

	bool endOfLoop = false;
	while (!endOfLoop) {

		if(presPlaying)
			emit signal_boxupdate();
			endOfLoop = true;
			for(list <Presentation *>::iterator ePres = aPres.begin(); ePres != aPres.end(); ePres++) {
				if((*ePres)->getState() != Presentation::PRES_READYTOPLAY) {
								endOfLoop = false;
				}
			}
	    SDL_Delay(250); 

		while (SDL_PollEvent (&event)) {
			switch (event.type) {
				case SDL_KEYDOWN:
					switch(event.key.keysym.sym) {
						case SDLK_SPACE:
							if(presPlaying) {
								for(list <Presentation *>::iterator plPres = aPres.begin(); plPres != aPres.end(); plPres++) {
									(*plPres)->pause((*plPres)->getSessionKey());
								}
								presPlaying = false;
							}
							else {
								for(list <Presentation *>::iterator paPres = aPres.begin(); paPres != aPres.end(); paPres++) {
									(*paPres)->play();
								}
								presPlaying = true;
							}
							break;
						case SDLK_ESCAPE:
						//	dial->stop();
						//	exitApp = true;
							break;
						case SDLK_f:
							if(presPlaying)
								endOfLoop = true; //fullScreen();
							break;
						default: break;
					}
					default: break;
					
			}

		}
		
		
	}
	SDL_ShowCursor(1);
	emit f_pressed();
}

bool  VideoWindow::eventQuit (int id, PG_MessageObject *widget, unsigned long data) {
	widget->EnableReceiver(false);
	return true;
}





