 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	VideoWindow.hpp                                               *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _VIDEOWINDOW_HPP_
#define _VIDEOWINDOW_HPP_

#include "Presentation.hpp"
#include "paragui.h"
#include "pgapplication.h"
#include <qobject.h>
#include <qevent.h>
#include <qwidget.h>
#include <list>


/**
 *
 * <Class Description goes here>
 *
 *@author Ronald Sowa
 *
 *@version $Id: VideoWindow.hpp,v 1.4 2006/02/13 12:29:31 klschoef Exp $
 *
 *@short <short description>
 *
 */
class VideoWindow : public QObject,public PG_Application {
	Q_OBJECT
public:
	VideoWindow();
	~VideoWindow();

	void setPresentations(list <Presentation *> actPres) {
		aPres = actPres;
	}
	void switchToFullscreen();


	
signals:
	void f_pressed();
	void space_pressed();
	void signal_boxupdate();
	
private:
	list <Presentation *> aPres;


protected:
	bool  eventQuit (int id, PG_MessageObject *widget, unsigned long data);
	
};
#endif
