#!/bin/bash


gen() {
  NUM=$1
  PLAYCL_FILE="./rtp_stat-playout-client-$NUM"
  STREAMCL_FILE="./rtp_stat-streamout-client-$NUM"
  STREAMSRV_FILE="./rtp_stat-streamout-server-$NUM"
  if [ ! -f $PLAYCL_FILE ]; then
    echo "file $PLAYCL_FILE not found!"
    return 1
  fi
  
  maxrealbw=`awk '{ if ($2+$3 > max) max=$2+$3} END {printf "%2.2f", max}' $STREAMCL_FILE`
  avgrealbw=`awk '{ sum=sum+$2+$3} END {printf "%2.2f", sum/FNR}' $STREAMCL_FILE`
  avgadapt=`awk '{ sum=sum+$10} END {printf "%2.2f", sum/FNR}' $STREAMSRV_FILE`
  avgpsnr=`awk '{ sum=sum+$8} END {printf "%2.2f", sum/FNR}' $PLAYCL_FILE`
  avgfps=`awk '{ sum=sum+$3} END {printf "%2.2f", sum/FNR}' $PLAYCL_FILE`
  sed s/-0/-$NUM/g PLOT-rtpstats | sed s/AVGADAPT/$avgadapt/g | \
      sed s/AVGREALBW/$avgrealbw/g | sed s/AVGPSNR/$avgpsnr/g | \
      sed s/AVGFPS/$avgfps/g | sed s/MAXREALBW/$maxrealbw/g | \
      gnuplot > PLOT-stream$NUM.ps

}


##### MAIN #####
NUM1=$1
NUM2=$2
if [ $# -eq 0 ]; then
    echo "USAGE: $0 FileNo_1 FileNo_2"
    echo "   eg. $0 0 1     will use rtp_stat-streamout-server-0 and rtp_stat-streamout-server-1"
    NUM1=0
    NUM2="orig"
    cp rtp_stat-streamout-client-1 rtp_stat-streamout-client-0
fi

#first stream
gen $NUM1
echo "first file done"

gen $NUM2
if [ $? -ne 0 ]; then
   echo "no second plot available"
   exit
fi
echo "second file done"

echo "preparing double stats"
  #stream comparison stats
		BOTHSTREAM_FILE=rtp_stat-streamout-server-both
		BOTHPLAY_FILE=rtp_stat-playout-client-both
  join rtp_stat-streamout-server-$NUM1 rtp_stat-streamout-server-$NUM2 > $BOTHSTREAM_FILE
  join rtp_stat-playout-client-$NUM1 rtp_stat-playout-client-$NUM2 > $BOTHPLAY_FILE


		avgpsnrdiff=`awk '{ sum=sum+$8-$19} END {printf "%3.2f", sum/FNR}' $BOTHPLAY_FILE`
		avgfpsdiff=`awk '{ sum=sum+$3-$14} END {printf "%3.2f", sum/FNR}' $BOTHPLAY_FILE`
		avgrealbwdiff=`awk '{ sum=sum+$3-$16} END {printf "%3.2f", sum/FNR}' $BOTHSTREAM_FILE`
  sed s/AVGPSNRDIFF/$avgpsnrdiff/g PLOT-rtpdoublestats | sed s/AVGREALBWDIFF/$avgrealbwdiff/g \
      | sed s/AVGFPSDIFF/$avgfpsdiff/g | gnuplot > PLOT-bothstreams.ps

