#!/bin/bash

DEV=eth1
LATENCY=20ms
BURST=5kb


#param1: rate
#param2: time in secs
setTC () {
  #tc qdisc add dev eth1 root tbf rate 256Kbit buffer 200kB limit 100kB
  tc qdisc replace dev $DEV root tbf rate $1 latency $LATENCY burst $BURST
  tc qdisc show dev $DEV
  sleep $2
}


#recursive stepping
#param1: start value in kbps
#param2: decrease percentage
#param3: time for each step in secs
#param4: number of wanted steps

#(internal param5: act step)
dostep () {
  local BASE=$1
  local PERC=$2
  local TIME=$3
  local STEP=$4
  [ ! -z $5 ] && local ACT_STEP=$5 || local ACT_STEP=$STEP

  setTC ${BASE}Kbit $TIME
  if [ $ACT_STEP -gt 0 ]; then
    local ACT=`echo "scale=5; $BASE * (1 - $PERC / 100)" | bc | cut -d . -f 1`
    dostep $ACT $PERC $TIME $STEP `expr $ACT_STEP - 1`

    if [ $ACT_STEP != $STEP ]; then
      setTC ${BASE}Kbit $TIME
    fi
  fi
}

tc qdisc del dev eth1 root

#setTC <RATE> <SECONDS>
while [ 1 ]; do
 #coarse grain (30% every 30 sec, 650,455,318)
 # dostep 650 30 30 2

 #fine grain (2% every second, 630->333 and up again)
 dostep 630 2 1 30
done


