<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="urn:mpeg:mpeg21:2002:01-DIDL-NS" xmlns:did="urn:mpeg:mpeg21:2002:01-DIDL-NS">
  <xsl:output method="html"/>
  <xsl:variable name="lowercase" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="uppercase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:template match="/">
    <html>
      <head>
        <title>muviserver - list of available movies, (c) by KS</title>
      </head>
      <style type="text/css">
				td {
					font-family:Verdana;
					font-size:8pt;
				}
				body {
					font-family:Verdana;
					font-size:8pt;
				}		
				font {
					color:darkblue;
					font-weight:bold;
					font-size:10pt;
				}		
			</style>
      <body>
        <h3>muviserver - list of available movies</h3>
        <hr size="1"/>
        <xsl:apply-templates/>
        <hr size="1"/>
        <br/>
        <font size="1">Created by Klaus Schöffmann, University of Klagenfurt - ITEC, 2004</font>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="//did:Item[1]">
    <br/>
    <table>
      <tr>
        <td colspan="2">
          <font size="3">
            <xsl:value-of select="./did:Choice/did:Descriptor/did:Statement[@mimeType='text/plain']"/>
          </font>
          <br/>
        </td>
      </tr>
      <xsl:for-each select="./did:Choice/did:Selection">
        <tr>
          <td>
            <img width="94" height="140">
              <xsl:attribute name="src"><xsl:value-of select="./did:Descriptor[3]/did:Component/did:Resource/@ref"/></xsl:attribute>
              <xsl:attribute name="alt"><xsl:value-of select="./did:Descriptor[1]/did:Statement[@mimeType='text/plain']"/></xsl:attribute>
            </img>
          </td>
          <td>
            <b>
              <xsl:value-of select="./did:Descriptor[1]/did:Statement[@mimeType='text/plain']"/>
            </b>
            <br/>
            <pre><xsl:value-of select="./did:Descriptor[2]/did:Statement[@mimeType='text/plain']"/></pre>
            <xsl:variable name="resLink">
              <xsl:call-template name="getResourceLinkByCondition">
                <xsl:with-param name="nodes" select="//did:Item[1]/did:Component"/>
                <xsl:with-param name="id" select="@select_id"/>
              </xsl:call-template>
            </xsl:variable>
            Watch it:
            <a>
              <xsl:attribute name="href"><xsl:value-of select="$resLink"/></xsl:attribute>
              <xsl:value-of select="translate(substring-after(substring-after(substring-after(substring-before($resLink, '.mp4'), ':'), ':'),'/'), $lowercase, $uppercase)"/>
            </a>
          </td>
        </tr>
      </xsl:for-each>
    </table>
  </xsl:template>
  <xsl:template name="getResourceLinkByCondition">
    <xsl:param name="nodes"/>
    <xsl:param name="id"/>
    <xsl:for-each select="$nodes">
      <xsl:if test="./did:Condition/@require=$id">
        <xsl:value-of select="./did:Resource/@ref"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
