 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: ServerCommunication.hpp                                       *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/
 
 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/
 
 
#ifndef __ServerCommunication_hpp__
#define __ServerCommunication_hpp__

#ifdef WIN32
#include <winsock2.h>
#else
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>
#endif


//#include <unistd.h>
#include <sys/types.h>

#include "global.hpp"

#include "SessionMgmt.hpp"
#include "SSession.hpp"

/**
 * This class is used for communication with 
 * the semiserver. It is responsible for sending
 * a list of currently active streaming-sessions
 * to the semiserver.
 *
 *@author Klaus Schoeffmann
 */
 
class ServerCommunication {

private:
  
  /** reference to session-management (used to retrieve sessionlist) */
  class SessionMgmt *sMgmt;
  /** socket to semiserver */
  int clientsock;
  /** address of semiserver */
  struct sockaddr_in* caller;
  
  
public:
  /** default constructor */
  ServerCommunication(int clientsock, struct sockaddr_in* caller, SessionMgmt *sMgmt);
  /** default destructor */
  ~ServerCommunication();
  /** Send a list of currently active sessions to the semiserver. */
  void sendSessionsToServer();
};

#endif

