 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: Track.cpp                                                     *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/


#include "Track.hpp"

/***********************************************************************/
Track::Track(uint trackNr)
{
  this->trackNr = trackNr;
  this->state = TRACK_CREATED;
  RtspSessionID = 0;
}

/***********************************************************************/
Track::~ Track()
{
  Globals::sdebug << " t" << trackNr;
}

/***********************************************************************/
void Track::setId(uint sessionID)
{
  this->RtspSessionID = sessionID;
  Globals::sdebug << "\nSetID of Track " << trackNr << " to " << sessionID << "\n";
}

/***********************************************************************/
void Track::setState(TrackState state)
{
  this->state = state;
}

/***********************************************************************/
uint Track::getId()
{
  return this->RtspSessionID;
}

/***********************************************************************/
uint Track::getNumber()
{
  return this->trackNr;
}

/***********************************************************************/
TrackState Track::getState()
{
  return this->state;
}
