 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: Track.hpp                                                     *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/


#ifndef __Track_hpp__
#define __Track_hpp__

#include <string>
#include <vector>
#include "SemiGlobals.hpp"

/**
 * This class is used by TrackList
 *
 * @author Klaus Schoeffmann
 */

enum TrackState {TRACK_CREATED, TRACK_ACTIVE, TRACK_PAUSED, TRACK_CLOSED};

class Track {

private:
  /** number of track */
  uint trackNr;
  /** RTSP-Session-ID of this track */
  uint RtspSessionID;
  /** state of current track */
  TrackState state;

public:

  /** default constructor */
  Track(uint trackNr);
  /** default destructor */
  ~Track();

  /** set Rtsp session id of track */
  void setId(uint sessionID);
  /** set state of track */
  void setState(TrackState state);
  /** get Rtsp session id of track */
  uint getId();
  /** get number of track */
  uint getNumber();
  /** get state of track */
  TrackState getState();
};

#endif
