/***********************************************************************
*                                                                      *
* ViTooKi                                                              *
*                                                                      *
* title: URIParameters.cpp                                             *
*                                                                      *
*                                                                      *
*                                                                      *
* ITEC institute of the University of Klagenfurt (Austria)             *
* http://www.itec.uni-klu.ac.at                                        *
*                                                                      *
*                                                                      *
* For more information visit the ViTooKi homepage:                     *
* http://ViTooKi.sourceforge.net                                       *
* vitooki-user@lists.sourceforge.net                                   *
* vitooki-devel@lists.sourceforge.net                                  *
*                                                                      *
* This file is part of ViTooKi, a free video toolkit.                  *
* ViTooKi is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License          *
* as published by the Free Software Foundation; either version 2       *
* of the License, or (at your option) any later version.               *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
* MA  02111-1307, USA.                                                 *
*                                                                      *
***********************************************************************/

/***********************************************************************
*                                                                      *
*  REVISION HISTORY:                                                   *
*                                                                      *
*                                                                      *
*                                                                      *
***********************************************************************/

/***********************************************************************
* Video Session Migration System, 2004                                 *
* Author: Klaus Schoeffmann                                            *
************************************************************************/


#include "URIParameters.hpp"


/***********************************************************************/
URIParameters::URIParameters()
{
  fullURI = NULL;
  movieId = NULL;
  userId = 0;
  profileId = 0;
  range = NULL;
  host = NULL;
  port = 0;
  sessionId = 0;
  action = 0;
  section = 0;
  subtractSecs = -1;
  Globals::sdebug << "\nURIParameters constructor called!";
}

/***********************************************************************/
URIParameters::~URIParameters()
{
  delete fullURI;
  fullURI = NULL;
  delete movieId;
  movieId = NULL;
  delete range;
  range = NULL;
  delete host;
  host = NULL;
}

/***********************************************************************/
void URIParameters::setFullURI(char* fullURI)
{
  if (fullURI != NULL)
  {
    this->fullURI = semifunc::newStrCpy(fullURI);
  }
  else
  {
    this->fullURI= NULL;
  }
}

/***********************************************************************/
void URIParameters::setMovieId(char* movieId)
{
  if (movieId != NULL)
  {
    this->movieId = semifunc::newStrCpy(movieId);
  }
  else
  {
    this->movieId = NULL;
  }
}

/***********************************************************************/
void URIParameters::setUserId(uint userId)
{
  this->userId = userId;
}

/***********************************************************************/
void URIParameters::setProfileId(uint profileId)
{
  this->profileId = profileId;
}

/***********************************************************************/
void URIParameters::setRange(char* range)
{
  if (range != NULL)
  {
    this->range = semifunc::newStrCpy(range);
  }
  else
  {
    this->range = NULL;
  }
}

/***********************************************************************/
void URIParameters::setHost(char* host)
{
  if (host != NULL)
  {
    this->host = semifunc::newStrCpy(host);
    Globals::sdebug << "\nURIParams::setHost(): host copied: " << this->host;
  }
  else
  {
    this->host = NULL;
  }
}

/***********************************************************************/
void URIParameters::setPort(uint port)
{
  this->port = port;
}

/***********************************************************************/
void URIParameters::setSessionId(uint sessionId)
{
  this->sessionId = sessionId;
}

/***********************************************************************/
void URIParameters::setAction(uint action)
{
  this->action = action;
}

/***********************************************************************/
void URIParameters::setSection(uint section)
{
  this->section = section;
}

/***********************************************************************/
void URIParameters::setSubtractSecs(int subtractSecs)
{
  this->subtractSecs = subtractSecs;
}

/***********************************************************************/
char* URIParameters::getFullURI()
{
  return fullURI;
}

/***********************************************************************/
char* URIParameters::getMovieId()
{
  return movieId;
}

/***********************************************************************/
uint URIParameters::getUserId()
{
  return userId;
}

/***********************************************************************/
uint URIParameters::getProfileId()
{
  return profileId;
}

/***********************************************************************/
char* URIParameters::getRange()
{
  return range;
}

/***********************************************************************/
char* URIParameters::getHost()
{
  return host;
}

/***********************************************************************/
uint URIParameters::getPort()
{
  return port;
}

/***********************************************************************/
uint URIParameters::getSessionId()
{
  return sessionId;
}

/***********************************************************************/
uint URIParameters::getAction()
{
  return action;
}

/***********************************************************************/
uint URIParameters::getSection()
{
  return section;
}

/***********************************************************************/
int URIParameters::getSubtractSecs()
{
  return subtractSecs;
}

