/***********************************************************************
*                                                                      *
* ViTooKi                                                              *
*                                                                      *
* title: embedded.cpp                                                  *
*                                                                      *
*                                                                      *
*                                                                      *
* ITEC institute of the University of Klagenfurt (Austria)             *
* http://www.itec.uni-klu.ac.at                                        *
*                                                                      *
*                                                                      *
* For more information visit the ViTooKi homepage:                     *
* http://ViTooKi.sourceforge.net                                       *
* vitooki-user@lists.sourceforge.net                                   *
* vitooki-devel@lists.sourceforge.net                                  *
*                                                                      *
* This file is part of ViTooKi, a free video toolkit.                  *
* ViTooKi is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License          *
* as published by the Free Software Foundation; either version 2       *
* of the License, or (at your option) any later version.               *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
* MA  02111-1307, USA.                                                 *
*                                                                      *
***********************************************************************/

/***********************************************************************
*                                                                      *
*  REVISION HISTORY:                                                   *
*                                                                      *
*                                                                      *
*                                                                      *
***********************************************************************/

/***********************************************************************
* Video Session Migration System, 2004                                 *
* Author: Klaus Schoeffmann                                            *
************************************************************************/


#include "embedded.hpp"


/***********************************************************************/
int main (void)
{

  cout << html::getHTMLHeader();
  cout << html::getMenu("embedded.cgi", 1);

  //read form data
  string formdata;
  cin >> formdata;
  CGIParser cgiparser (formdata);
  char *uri = semifunc::newStrCpy((char*)cgiparser.getFieldValue("uri").c_str());
  uint width = atoi(cgiparser.getFieldValue("width").c_str());
  uint height = atoi(cgiparser.getFieldValue("height").c_str());

  cout << "<object classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\"" << endl;
  cout << " codebase=\"https://www.apple.com/qtactivex/qtplugin.cab\"";
  cout << " width=\"" << (width+50) << "\" ";
  cout << " height=\"" << (height+50) << "\"";
  cout << ">" << endl;

  cout << "<param name=\"qtsrc\" value=\"" << uri << "\"/>" << endl;
  cout << "<param name=\"autoplay\" value=\"true\"/>" << endl;
  cout << "</object>" << endl;

  cout << "<script language=\"JavaScript\">";
  cout << "window.resizeTo(" << (width+150) << "," << (height+250) << ");";
  cout << "</script>";

  cout << html::getHTMLFooter(cgiparser.createRefreshForm("embedded.cgi", "post"));

  delete uri;
  return 0;
}
