 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: readprofiles.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/
 
 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/

#ifndef __readprofiles_hpp__
#define __readprofiles_hpp__
 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "UserList.hpp"
#include "User.hpp"
#include "ProfileList.hpp"
#include "Profile.hpp"
#include "SemiGlobals.hpp"
#include "CGIParser.hpp"

/** Create a selection box of profiles for a specified user. */
void createProfileSelection(UserList *ul, uint userId);

/** Create the javascript-code which is used for input-protection. */
void createJavaScriptCode(UserList *ul, uint userId);

/**
 * This program is used as a CGI-program at the semiserver 
 * to provide a selection of corresponding profiles (and a password-field) 
 * for a specified user.
 *
 * @author Klaus Schoeffmann
 */
 int main ();

#endif

