/***********************************************************************
*                                                                      *
* ViTooKi                                                              *
*                                                                      *
* title: semiserver.cpp                                                *
*                                                                      *
*                                                                      *
*                                                                      *
* ITEC institute of the University of Klagenfurt (Austria)             *
* http://www.itec.uni-klu.ac.at                                        *
*                                                                      *
*                                                                      *
* For more information visit the ViTooKi homepage:                     *
* http://ViTooKi.sourceforge.net                                       *
* vitooki-user@lists.sourceforge.net                                   *
* vitooki-devel@lists.sourceforge.net                                  *
*                                                                      *
* This file is part of ViTooKi, a free video toolkit.                  *
* ViTooKi is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License          *
* as published by the Free Software Foundation; either version 2       *
* of the License, or (at your option) any later version.               *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
* MA  02111-1307, USA.                                                 *
*                                                                      *
***********************************************************************/

/***********************************************************************
*                                                                      *
*  REVISION HISTORY:                                                   *
*                                                                      *
*                                                                      *
*                                                                      *
***********************************************************************/

/***********************************************************************
* Video Session Migration System, 2004                                 *
* Author: Klaus Schoeffmann                                            *
************************************************************************/


#include "net/HttpServer.hpp"


static HttpServer *hs;


/**********************************************************************/
void sighandlersrv(int sig)
{
  switch(sig) {
    case SIGINT:
      if (hs) {
        printf("\nstopping httpserver..");
        hs->stop();
        delete hs;
        printf("ok");
      } else {
      	printf("\nexit without stopping httpserver...");
      }
      hs = NULL;
      exit(1);
      break;
    default:
      printf("got unhandled signal...\n");
  }
}

/**********************************************************************/
int main(int argc, char *argv[])
{
  signal(SIGINT, sighandlersrv);
  int port = 8081;

  if (argc > 1) port = atoi(argv[1]);

  hs = new HttpServer(port, ".", "/cgi-bin/");
  hs->start();

  while (1) msleep(100);

  return 0;
}
