/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: ProfileList.hpp  (S H A R E D)                                *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/


#ifndef __ProfileList_hpp__
#define __ProfileList_hpp__

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include "Profile.hpp"
#include "SemiGlobals.hpp"
#include "UserList.hpp"

using namespace std;

/**
 * This class is used to read user-profiles into memory.
 *
 * @author Klaus Schoeffmann
 */

class ProfileList
{
  private:
    /** list of all profiles */
    vector<Profile*> list;
    /** add the specified profile to the list */
    void addProfile(Profile* d);

  public:
    /** default constructor */
    ProfileList();
    /** default destructor */
    ~ProfileList();
    /** read all profiles from specified file into memory
        and add a reference to this profile to every appropriate user */
    void readProfilesFromFile(const char *filename, UserList *ul);
    /** @return a reference to the profile with specified id */
    Profile *getProfileById(const uint profileId);
};
#endif
