/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: User.cpp  (S H A R E D)                                       *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

/***********************************************************************
*                                                                      *
*  REVISION HISTORY:                                                   *
*                                                                      *
*                                                                      *
*                                                                      *
***********************************************************************/

/***********************************************************************
* Video Session Migration System, 2004                                 *
* Author: Klaus Schoeffmann                                            *
************************************************************************/


#include "User.hpp"

/***********************************************************************/
User::User(uint userId, char username[], char password[])
{
  if (strlen(username) > USERNAME_MAXLEN || strlen(password) > PASSWORD_MAXLEN)
  {
    cerr << "\nUser::User(): Cannot create User: too long name/pass";
    exit(1);
  }
  else
  {
    this->userId = userId;
    strcpy(this->username, username);
    strcpy(this->password, password);
  }
}

/***********************************************************************/
User::~User()
{
  Globals::sdebug << " u" << userId;
  profiles.clear();
}

/***********************************************************************/
void User::addProfile(Profile *profile)
{
  profiles.push_back(profile);
}

/***********************************************************************/
char* User::getUsername()
{
  return username;
}

/***********************************************************************/
char* User::getPassword()
{
  return password;
}

/***********************************************************************/
uint User::getUserId()
{
  return userId;
}

/***********************************************************************/
vector<Profile*> User::getProfiles()
{
  return profiles;
}
