/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: UserList.hpp  (S H A R E D)                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 * Video Session Migration System, 2004                                 *
 * Author: Klaus Schoeffmann                                            *
 ************************************************************************/


#ifndef __UserList_hpp__
#define __UserList_hpp__

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include "User.hpp"
#include "SemiGlobals.hpp"

using namespace std;

/**
 * This class is used to read users into memory.
 *
 * @author Klaus Schoeffmann
 */

class UserList
{
  private:
    /** list of all users */
    vector<User*> list;

  public:
    /** default constructor */
    UserList();
    /** default destructor */
    ~UserList();
    /** add the specified user to the list */
    void addUser(User* u);
    /** @return user with the specified username */
    User* getUserByName(const char *username);
    /** @return user with the specified id */
    User *getUserById(const uint userId);
    /** @return a reference to the internal list of users */
    vector<User*> getUsers();
    /** read all users from the specified file into memory */
    void readUsersFromFile(const char *filename);
};
#endif
