#ifndef _HF_DESTINATIONAUDIOIMPL_HPP
#define _HF_DESTINATIONAUDIOIMPL_HPP
#include "DestinationAudio.hpp"
#include <cstdio>
#include "AudioESInfo.hpp"

class JobList;
class AudioESInfo;

#define MAX_ARRAY 100
#define MAX_SAMPLE 12
#define MAX_BPSAMPLE 4
//Extension Language
#define MAX_LANGUAGE 3


//class ContainerInfo;

class DestinationAudioImpl : public DestinationAudio{
	Q_OBJECT
public:
	DestinationAudioImpl(AudioESInfo* esinfo, 
			     JobList* globaljoblist,
			     bool newJob,
			     u32 job_id,
			     QWidget* parent = 0, 
			     const char* name = 0, 
			     bool modal = FALSE,
			     WFlags fl = 0 );

	~DestinationAudioImpl();

public slots:
    void new_job();
    void del_job();
    void load_joblist();
    void save_joblist();
    void cancel();
    void save();
    void update_job();
    void joblist_selected();
    void reset_form();
    void outputfile_textChanged();
    void outputfile_returnPressed();


protected:
    QGridLayout* cancel_save;
    JobList* globaljoblist;
    JobList* localjoblist;
    AudioESInfo* esinfo;
    bool newJob;
    u32 job_id;
    int samplearray[MAX_SAMPLE];
    int bpsamplearray[MAX_BPSAMPLE];
    char* languagearray[MAX_LANGUAGE];


private:
    void init();
   
    void fill_in_form(const char* c_name,
			      int i_bitsPerSecond,
			      int i_samplerate,
			      int i_bitsPerSample,
			      int i_channels,
			      const char* c_codec_id,
			      const char* c_language,
			      int i_audio_s_sec,
			      int i_audio_s_ms,
			      int i_audio_e_sec,
			      int i_audio_e_ms
			      );

    void write_jobs_to_joblist();
    void save_job(const char* c_outFile);
    void first_settings();
    void fill_in_codec();
    void set_Codec_ID(CodecID cid);
    bool load_joblist_intern();
    QString get_name_of_input();
    void set_disabled(bool ed);


};
#endif // _HF_DESTINATIONAUDIOIMPL_HPP
