#ifndef _HF_DESTINATIONVIDEOIMPL_HPP
#define _HF_DESTINATIONVIDEOIMPL_HPP
#include "DestinationVideo.hpp"
#include <cstdio>
#include "VideoESInfo.hpp"

#include <qlayout.h>
#include <qlistview.h>
#define MAX_ARRAY 100

class ContainerInfo;
class JobList;

class DestinationVideoImpl : public DestinationVideo{
	Q_OBJECT
public:
    DestinationVideoImpl(
                     VideoESInfo* esinfo,
                     JobList* globaljoblist,
		     bool newJob = FALSE,
		     u32 job_id = 0,
		     QWidget* parent = 0,
		     const char* name = 0,
		     bool modal = FALSE,
		     WFlags fl = 0 );
		     
    ~DestinationVideoImpl();
    
protected slots:
    void del_job();
    void new_job();
    void update_job();
    void load_joblist();
    void save_joblist();
    void cancel();
    void save();
    void var_gop_clicked();
    void only_i_frame_clicked();
    void var_frame_rate_clicked();
    void en_video_pac_clicked();
    void b_frame_slide_sliderMoved( int );
    void joblist_selected();
    void reset_form();
    void color_clicked();
    void bitrate_valueChanged(int);
    void size_activated(int);
    void outputfile_returnPressed();
    void outputfile_textChanged();
    void fixed_quantisation_clicked();



protected:
    QVBoxLayout* frameLayout;
    QGridLayout* cancel_save;
    JobList* globaljoblist;
    JobList* localjoblist;
    VideoESInfo* esinfo;
    QListView* mt_listView_job;
    bool newJob;
    u32 job_id;
    int w_size_array[MAX_ARRAY];
    int h_size_array[MAX_ARRAY];
    float current_aspect_ratio;
    int current_index_size;

private:
    void fill_in_form(const char* name,
                      int i_bitsPerSecond,
		      int i_bitrate_min, 
		      int i_bitrate_max,
		      int i_width,
		      int i_height,
		      CodecID codec_id,
		      float f_aspect_ratio,
		      bool b_color,
		      int i_macro_min,
		      int i_macro_max,
		      int i_quanti_min,
		      int i_quanti_max,
		      int i_I_frame,
		      int i_P_frame,
		      int i_B_frame,
		      bool b_var_gob,
		      bool b_only_i_frame,
		      bool b_var_frame_rate,
		      int i_gop_size,
		      int i_b_frame_slide,
		      int i_fps, 	
		      int i_dec_buffer_size,
		      bool i_en_video_pac,
		      int i_video_pac_size,
		      int i_video_s_sec,
		      int i_video_s_ms,
		      int i_video_e_sec,
		      int i_video_e_ms
		      );
    void init();
    void write_jobs_to_joblist();
    void first_settings();
    void save_job(const char* c_outFile);
    void set_gop_pattern(int i_slider);
    bool load_joblist_intern();
    QString get_name_of_input();
    void fill_in_codec();
    void set_Codec_ID(CodecID cid);
    void set_disabled(bool ed);



};
#endif
