 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	adaptationenginedialog.cpp                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include <qfiledialog.h>
#include <qlineedit.h>
#include <qgroupbox.h>
#include <qlistview.h>
#include <qapplication.h>
#include <qstring.h>
#include <qcheckbox.h>
#include <qtextedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qobject.h>
#include <iostream>

#include "MultiTranscoderImpl.hpp"
#include "EditSystemFileImpl.hpp"
#include "ESInfo.hpp"
#include "Source.hpp"
#include "SourceList.hpp"
#include "main.hpp"
#include "SystemFile.hpp"
#include "SystemFileList.hpp"

EditSystemFileImpl::EditSystemFileImpl(QWidget* parent, const char* name, bool modal, WFlags fl, QListView* qlv, QListViewItem* qlvi): EditSystemFile( parent, name, modal, fl )
{
	this->qlv=qlv;
	this->qlvi=qlvi;
	es_textEdit_outputfile->setFocus();

	//edit a existing systemfile
	if(qlvi != 0){
		SystemFile *sys;
		SystemFileList *sysl;
		es_textEdit_outputfile->setText(qlvi->text(1));

		if( !(sysl=project->getSystemFileList()) ){
			dprintf_err("ERROR:EditSystemFileImpl: getSystemFileList()\n");
		}
		else{
			if( !(sys=sysl->get((qlvi->text(1)).latin1())) ){
				dprintf_err("ERROR:EditSystemFileImpl: get()\n");
			}
			else{
				if(sys->getInterleave())
					es_checkBox_interleave->setChecked(TRUE);
				if(sys->getStreamable())
					es_checkBox_streaming->setChecked(TRUE);
			}//else
		}//else
	}//if
}

EditSystemFileImpl::~EditSystemFileImpl()
{

}

void EditSystemFileImpl::es_cancel()
{
    this->done(-1);
}

void EditSystemFileImpl::es_safe()
{
	SystemFile *sys = new SystemFile();
	SystemFileList *sysl;
	QString name;
	QListViewItem* it;

	//new Systemfile
	if(qlvi == 0){
		QString name = es_textEdit_outputfile->text();
		if(name.isEmpty()){
			dprintf_err("ERROR:es_safe:new: No Systemfilename\n");
		}
		else{
			if((qlv->findItem(name, 1)) ){
				dprintf_err("ERROR:es_safe:new: Systemfilename already exists\n");
			}
			else{
				sys->setName(name.latin1());
				if(es_checkBox_interleave->isChecked())
					sys->setInterleave(TRUE);
				if(es_checkBox_streaming->isChecked())
					sys->setStreamable(TRUE);

				if( !(sysl=project->getSystemFileList()) ){
					dprintf_err("ERROR:es_safe: getSystemFileList()\n");
				}
				else{
					if( !(sysl->add(sys)) ){
						dprintf_err("ERROR:es_safe: add()\n");
					}
					else{
						QString filename = "./images/systemfile.png";
						QPixmap* pixmap = new QPixmap(filename);
						QListViewItem *last = qlv->lastItem();
						it = new QListViewItem(qlv,last,QString(""),name);
						it->setPixmap(0,*pixmap);
						qlv->ensureItemVisible(it);
						it->setDragEnabled (TRUE);
						qlv->show();
						this->done(0);
					}//else
				}//else
			}//else
		}//else
	}//if
	//edit a existing systemfile
	else if(qlvi != 0){
		if( !(sysl=project->getSystemFileList()) ){
			dprintf_err("ERROR:es_safe: getSystemFileList()\n");
		}
		else{
			if( !(sys=sysl->get((qlvi->text(1)).latin1())) ){
				dprintf_err("ERROR:es_safe: get()\n");
			}
			else{
				QString name = es_textEdit_outputfile->text();
				if(name.isEmpty()){
					dprintf_err("ERROR:es_safe:new: No Systemfilename\n");
				}//else
				else{
					//different name
					if( (QString::compare(name,qlvi->text(1))) != 0){
						if((qlv->findItem(name,1)) ){
							dprintf_err("ERROR:es_safe:new: Systemfilename already exists\n");
						}
						else{
							sys->setName(name.latin1());

							if(es_checkBox_interleave->isChecked())
								sys->setInterleave(TRUE);
							else
								sys->setInterleave(FALSE);

							if(es_checkBox_streaming->isChecked())
								sys->setStreamable(TRUE);
							else
								sys->setStreamable(FALSE);

							qlvi->setText(1,name);
							qlv->show();
							this->done(0);
						}//else
					}//if
					else{
						if(es_checkBox_interleave->isChecked())
							sys->setInterleave(TRUE);
						else
							sys->setInterleave(FALSE);

						if(es_checkBox_streaming->isChecked())
							sys->setStreamable(TRUE);
						else
							sys->setStreamable(FALSE);

						qlvi->setText(1,name);
						qlv->show();
						this->done(0);
					}//else
				}//else
			}//else
		}//else
	}//else if
}//es_safe

