 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	GlobalOptionsimpl.hpp                                         *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef MULTITRANSCODERIMPL_HPP
#define MULTITRANSCODERIMPL_HPP
class EditSystemFileImpl;
class SourceList;
class JobList;

#include "MultiTranscoder.hpp"

class MultiTranscoderImpl : public MultiTranscoder
{
	Q_OBJECT
public:
	MultiTranscoderImpl( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    	virtual ~MultiTranscoderImpl();

	EditSystemFileImpl *dialog;

protected slots:
	    void mt_addSource();
    	void mt_delSource();
    	void mt_addJob();
    	void mt_addSys();
    	void mt_delJob();
    	void mt_loadProject();
    	void mt_saveProject();
	    void mt_renameProject();
	    void mt_delSys();
    	void mt_infoSource();
    	void mt_editJob();
    	void mt_editSys();
    	void mt_transcode();
    	void mt_saveQuitProject();
    	void mt_downFile();
	    void mt_cancel();
	    void mt_check_Source(QListViewItem* item);
      void mt_control_Job_button(QListViewItem* item);
      void mt_control_Systemfile_button(QListViewItem* item);
	    void mt_workingDir();
};

#endif
