#include "ProgressImpl.hpp"

#include <stdio.h>
#include <stdlib.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qspinbox.h>
#include <qtextedit.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qstring.h>
#include <qprogressbar.h>

#include "JobList.hpp"
#include "Job.hpp"

#include "Project.hpp"
#include "Transcoder.hpp"

//-----------------------------------------------------------------

//------------------------ Konstructor ----------------------------
ProgressImpl::ProgressImpl( int project_total_steps,
                            Project* project,
			    QWidget* parent,
			    const char* name,
			    bool modal, 
			    WFlags fl)
:Progress(parent,name,modal,fl){
	//this->project_total_steps=project_total_steps;
	this->project=project;
	this->project_total_steps=10;

	init();	
}//ProgressImpl

//-------------------------- Destructor ---------------------------

ProgressImpl::~ProgressImpl(){

}//ProgressImpl

//-------------------------- INIT ---------------------------------

void ProgressImpl::init(){
	//FIX ME one Project more Jobs!
	//Transcoder von Sigrid aufrufen!
	const char* c_project_name;
	double d_project=0;
	Transcoder* trans;
	char* c_jobs_in_list=(char*)malloc(MAX_STR_LEN);
	memset(c_jobs_in_list,0,MAX_STR_LEN);

	QString name("/home/helga/testing_this");
	if(name){
		assert(name);
		FILE* file = fopen(name,"w+");
		if(file){
			assert(file);
						
	c_project_name=project->getName();
	QString q_project_name(c_project_name);
	project_name->setText(q_project_name);
	project_progress->setTotalSteps(this->project_total_steps);
	
	trans = new Transcoder(this->project);
	trans->start();
	while(d_project<1){
		d_project=trans->getProgress();
		sprintf(c_jobs_in_list,"d_project: %f\n",(float)d_project);
		fputs(c_jobs_in_list,file);
		sleep(2);
		do_project_progress((int)(d_project*this->project_total_steps));
	}//while
	sprintf(c_jobs_in_list,"\nd_project: %f\n",(float)d_project);
	fputs(c_jobs_in_list,file);
	
	do_project_progress((int)(d_project*this->project_total_steps));

		fclose(file);
		

		}//if
	}//if
	free(c_jobs_in_list);
}//init

//------------------------DO JOB PROGRESS -------------------------

void ProgressImpl::do_job_progress(int job_state){
	job_progress->setProgress(job_state);
}//do_job_progress

//----------------------DO PROJECT PROGRESS -----------------------

void ProgressImpl::do_project_progress(int project_state){
	QString q_final("FINISHED");
	
	project_progress->setProgress(project_state);
	
	if(project_state==project_total_steps){
		final->setText(q_final);
		b_quit->setDisabled(false);
	}//if
}//do_project_progress

//------------------------ NEW JOB --------------------------------

void ProgressImpl::new_job(Job* job,int job_total_steps){
	const char* c_job_name;
	c_job_name=job->getName();
	QString q_job_name(c_job_name);
	job_name->setText(q_job_name);
	job_progress->setTotalSteps(job_total_steps);
}//new_job

//------------------------ CANCEL ----------------------------------

void ProgressImpl::cancel(){
	//stop transcoder
	this->done(-1);
}//cancel

//------------------------ QUIT ------------------------------------

void ProgressImpl::quit(){
	this->done(0);
}//quit

