/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   SourceList.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef __SOURCELIST_HPP__
#define __SOURCELIST_HPP__

#include <list>
class JobList;
class Source;
#include "ESInfo.hpp"

class SourceList {

protected:
	std::list<Source*> sources;

public:
	/** constructor */
	SourceList();

	/** destructor */
	virtual ~SourceList();
		
	/** return is false if a job with the same identifier already exists */
	bool add(Source* s);
	
	bool remove(Source* s); //only unlinks from list, dont free!

	/** searches for a source with the name of the ESInfo and the StreamID */
	Source* get(const char* outFileName, u32 streamId);

	/** returns Source on position with given index */
	Source* getSourceByIndex(u32 index);
	
	/** prints all data of the sourcelist */
	bool toStringFull(char* output, int max_len);
	char* toStringFull();

	/** only prints data of ESInfo of all sources */
	bool toStringESInfo(char* output, int max_len);
	char* toStringESInfo();

	/** reads sources and creates them if the flag is true */		
	bool fromString(const char* initString, SourceList* sl, JobList* jl, bool flag);
			
}; //class

#endif
