 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	adaptationenginedialog.cpp                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include <qfiledialog.h>
#include <qlineedit.h>
#include <qgroupbox.h>
#include <qlistview.h>
#include <qapplication.h>
#include <qstring.h>
#include <qcheckbox.h>
#include <qtextedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qobject.h>
#include <iostream>

#include "WorkingDirectoryImpl.hpp"
#include "main.hpp"




WorkingDirectoryImpl::WorkingDirectoryImpl( QWidget* parent, const char* name, bool modal, WFlags fl ): WorkingDirectory( parent, name, modal, fl )
{

}

WorkingDirectoryImpl::~WorkingDirectoryImpl()
{

}

void WorkingDirectoryImpl::wd_cancel()
{
    this->done(-1);
}

void WorkingDirectoryImpl::wd_browse()
{
	QFileDialog* fd = new QFileDialog(this, "file dialog", TRUE);
	QString name = fd->getExistingDirectory("/home", this, "get existing directory", "Set workingdirectory", TRUE );
	wd_textEdit_directory->setText(name);
}

void WorkingDirectoryImpl::wd_save()
{
	QString name = wd_textEdit_directory->text();
	if(name.isEmpty()){
		dprintf_err("ERROR:wd_safe: workingdirectory empty\n");
	}
	else{
		project->setWorkingDirectory(name.latin1());
		this->done(0);
	}
}










