 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: main.cpp                                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/


#include <qapplication.h>
#include "global.hpp"
#include "vitooki.hpp"
#include "MultiTranscoderImpl.hpp"
#include "Project.hpp"
#include "Transcoder.hpp"
#ifdef WIN32
#include <windows.h>
#endif

MultiTranscoderImpl *dialog = NULL;
Project* project=new Project("Default");

int main(int argc, char **argv)
{
	vitooki_init_all();

	if(argc > 1)
	{
		if(!project->load(argv[1]))
		{
			dprintf_err("\033[31mmain: cannot load project\033[0m\n");
			_exit(1);
		}
		else
		{
			Transcoder* transcoder = new Transcoder(project);
			transcoder->start();
			sleep(2);
			while(99.9999 > transcoder->getProgress())
			{
				sleep(1);
			}
			printf("going to wait\n");
			transcoder->wait();
			return 1;
		}
	}
	
	QApplication a(argc, argv);
	dialog = new MultiTranscoderImpl(0,0,TRUE);
	a.setMainWidget(dialog);
	dialog->show();
	a.exec();
	return 0;
}
