<?php
$page_title = "MuViNo";
define('PATH_TO_ROOT','../../');
include(PATH_TO_ROOT.'include/page_header.php');
?>
<h1>MuViNo - An MPEG-7 Video Annotation Tool</h1>
<p>
MuViNo is a tool for creating MPEG-7 metadata of videos. It consists of an embedded video player and an XML tree view allowing to navigate and edit an MPEG-7 document. It was designed to facilitate the creation and annotation of MPEG-7 <tt>VideoSegment</tt> descriptions, by which a video can be divided temporally into a hierarchy of semantic sections, like the chapters and sections of a printed book.<p>
<tt>VideoSegment</tt> descriptors are created by splitting the <em>current segment</em> into subsegments at the current media time point shown in the video player. Special slider widgets facilitate quick navigation within the <tt>VideoSegment</tt> tree. The annotation data belonging to a <tt>VideoSegment</tt> can be edited in a user-friendly dialog, there is no need to manipulate the XML tree directly.<p>
MuViNo supports the following MPEG-7 descriptors within a <tt>VideoSegment</tt>: 
<ul>
<li>
<tt>CreationInformation/Creation/Title</tt> </li>
<li>
<tt>CreationInformation/Creation/TitleMedia/TitleImage</tt> </li>
<li>
<tt>CreationInformation/Creation/Abstract</tt> </li>
<li>
semantic place and semantic time within the <tt>Semantic</tt> descriptor </li>
<li>
<tt>FreeTextAnnotation</tt> and <tt>KeywordAnnotation</tt> within <tt>Abstract</tt> (see above) and <tt>TextAnnotation</tt> </li>
<li>
<tt>MediaTime</tt> and <tt>TemporalDecomposition</tt> - maintained automatically by MuViNo </li>
</ul>
	
<h2 id="screenshots">Screenshots</h2>
<p><ins><ul>
<li><a href="muvino-main-shot.jpg">Main Window</a></li>
<li><a href="muvino-edit-shot.jpg">Video Segment Edit Dialog</a></li>
</ul></ins></p>
<?php
include(PATH_TO_ROOT.'include/page_footer.php');
?>
