<?php 
$page_title = "CVS guide for developers";
define('PATH_TO_ROOT','../');
include(PATH_TO_ROOT.'include/page_header.php');
?>
<h1>CVS guide for developers</h1>
<p>Every developer has to perform a login via ssh at vitooki.cvs.sourceforge.net before he gets write access to the repository!
<ins><pre class="code">ssh -l &lt;SOURCEFORGEUSERNAME&gt; vitooki.cvs.sourceforge.net</pre></ins>
Don't be surprised if sourceforge logs you out immediately after login.
This is expected behaviour ;-)
<br/>
 Note that from now on, it's not necessary to do a cvs login any longer.</p>

<h2>Linux</h2>
<p>Add to ~/.bashrc :<br/>
<ins><pre class="code">
export CVS_RSH=ssh
export CVSROOT=:ext:SOURCEFORGEUSERNAME@vitooki.cvs.sourceforge.net:cvsroot/vitooki
</pre></ins></p>
<p>To avoid retyping your password before every CVS action you 
should generate a ssh key pair:
<ins><pre class="code"> ssh-keygen -tdsa</pre></ins>
Specify a fileName like /home/UNIXUSERNAME/.ssh/sourceforge.key.
Specify a passphrase (or leave it empty, if you're lazy and don't care about security)
Login to Sourceforge.
Go to <a href="https://sourceforge.net/account/editsshkeys.php">https://sourceforge.net/account/editsshkeys.php</a>
Do a "cat ~/.ssh/sourceforge.key.pub." (Don't use the less cmd!)
Copy/paste the key from the console to the browser.
Click update and check that the number of keys increased by 1 only!
Get a pizza and wait 20 minutes :-)
If you have protected your private key with a passphrase, you have to
call "ssh-add ~/.ssh/sourceforge.key" once before connecting to sourceforge.
</p>
<p>Try to do a cvs update, checkout, whatever. No password should be needed.
<ins><pre class="code">cvs checkout vitooki</pre></ins></p>

<h2>Windows</h2>
<p>Go to <a href="http://www.chiark.greenend.org.uk/~sgtatham/putty/download.html">http://www.chiark.greenend.org.uk/~sgtatham/putty/ download.html</a>
 Download Putty.exe plink.exe Pageant.exe and Puttygen.exe</p>
 <p>Go to <a href="http://sourceforge.net/docman/display_doc.php?docid=766&amp;group_id=1#sshkeygen">http://sourceforge.net/docman/ display_doc.php?docid=766&amp;group_id=1#sshkeygen</a>; read and do the following:
 <ins><ul>
 	<li><b>Generate a SSH key pair:</b><br/>
		Start puttygen.exe<br/>
		Generate a SSH1 key with length 1024 bits.<br/>
		Save the private key. Do NOT close the window!</li>
	<li><b>Upload your key to Sourceforge, wait 20 minutes:</b><br/>
		Login to Sourceforge.<br/>
		Goto <a href="https://sourceforge.net/account/editsshkeys.php">https://sourceforge.net/account/editsshkeys.php</a><br/>
		Copy your public key from the puttygen Window to the browser and click update.</li>
	<li><b>Configure pageant:</b><br/>
		Simply start pageant.exe, right-click-&gt;"Add Key" and add your private key.<br/>
		You might want to add pageant.exe to your Autostart Folder.</li>
 </ul></ins></p>
 <h3>WinCVS</h3>
  <p>If you are using WinCVS 1.2 stick to the guide from sourceforge. 
  (<a href="http://sourceforge.net/docman/display_doc.php?docid=766&amp;group_id=1#wincvsconfig">Guide on sf.net</a>)<br/>
  <br/> This guide is WinCVS 1.3 only!<br/><br/>
  Go to Admin-&gt;Preferences-&gt;General
 <br/>Authentication should be "ssh" (click on settings and specify the path to
 the private key and the path to plink.exe as ssh client)
 <br/><b>Path:</b> /cvsroot/vitooki
 <br/><b>Host Address:</b> vitooki.cvs.sourceforge.net
 <br/>CVSROOT=:ext:username@vitooki.cvs.sourceforge.net:cvsroot/vitooki
 <br/>
 <br/>Make sure that pageant.exe is running, when you access the CVS repository!</p>
<?php
include(PATH_TO_ROOT.'include/page_footer.php');
?>
