<?php 
$page_title = "Welcome to ViTooKi - The Video ToolKit";
define('PATH_TO_ROOT','./');
include('include/page_header.php');
?>
<h1>Welcome to ViTooKi - The Video ToolKit</h1>
<p>The Video-Toolkit is a operating system independent, powerful high-level
C++ multimedia library developed to simplify the implementation of multimedia
applications, e.g. with ViTooKi it's possible to write a commandline
movieplayer in less than 15 lines of code that runs on either Linux-PCs,
 Linux-iPAQs and Windows!</p>
 
<p>ViTooKi supports
<ins><ul>
	<li>standard compliant video streaming via RTP/UDP</li>
	<li>standardized RTP extensions to allow intelligent retransmission of lost frames</li>
	<li>RTSP and HTTP support</li>
	<li>real-time adaptation according to the client's terminal capabilities, i.e.
  		a mobile user can specify that its maximum display resolution is just 240x180
		and an adaptive video server will transcode the requested video in real-time
		to this resolution and send it to the client, thus reducing network bandwidth
		and client CPU usage
	<li>meta-data support: MPEG-21 is used for describing terminal capabilities and user
		preferences, MPEG-7 for adding semantic information to a video (e.g.: actors in a
		specific scene of a video)
	<li>MPEG-1, MPEG-2, MPEG-4 and any other video format supported by the ffmpeg or xvid library</li>
        <li>OGG Vorbis/Theora support</li>
	<li>Containers like .mp4, .avi are supported by ffmpeg, .mkv, .ogg  or (if available) .mp4 via ISOMP4</li>
	<li>MP3 audio is decoded via ffmpeg or via libmad (optimized for ipaq)</li>
 </ul></ins></p>

<p>The complete ViTooKi package consists of the main library, several small examples
that illustrate how to use the library, and some larger multimedia
applications like an adaptive media server, an adaptive media proxy, a
multi video player etc.
<br/>Each of these applications has a separate webpage where more detailed information
is available.</p>

<p style="padding-top:1em">This project is part of the Admits (<a href="http://admits-itec.uni-klu.ac.at/" target="_blank">http://admits-itec.uni-klu.ac.at/</a>) project, which is supervised by 
<a href="http://www.ifi.uni-klu.ac.at/ITEC/Staff/Laszlo.Boszormenyi" target="_blank">Prof. Laszlo B&ouml;sz&ouml;rmenyi</a> 
and <a href="http://www.ifi.uni-klu.ac.at/ITEC/Staff/Hermann.Hellwagner" target="_blank">Prof. Hermann Hellwagner</a>. 
Admits was funded in part by FWF (Fonds zur F&ouml;rderung der wissenschaftlichen Forschung) 
P14788 and by KWF (K&auml;rntner Wirtschaftsf&ouml;rderungsfonds)</p>
<p><a href="http://ffmpeg.org/" target="_blank"><img src="images/ffmpeg-button.gif"></a>
</p>

<h2>Browser information:</h2>
<p>This website uses CSS for defining styles. Older browsers (but esp.
	NetscapeNavigator4) don't support these features. If you're 
	using NetscapeNavigator4 you see a version of this site 
	<u>without</u> any styles.
	</p>
<?php
include('include/page_footer.php');
?>
