 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	PerformanceTest.hpp                                           *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#if !defined(AFX_PERFORMANCETEST_H__8595BD5E_844F_4792_B650_C3B2773AB34B__INCLUDED_)
#define AFX_PERFORMANCETEST_H__8595BD5E_844F_4792_B650_C3B2773AB34B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VideoESInfo.hpp"
#include "global.hpp"
#include "container/ContainerFile.hpp"
#include "VideoAdaptorChain.hpp"
#include "adaptors/MP4Decoder.hpp"
#include "adaptors/MP4Encoder.hpp"
#include "ContainerInfo.hpp"
#include "adaptors/YUVColorReductionAdaptor.hpp"
#include "adaptors/YUVSpatialReductionAdaptor.hpp"
#include "adaptors/QualityReductionAdaptor.hpp"
#include "adaptors/ColorReductionAdaptor.hpp"
#include "adaptors/SpatialReductionAdaptor.hpp"
#include "adaptors/TemporalAdaptor.hpp"
#include "adaptors/StrongTemporalAdaptor.hpp"
#include "adaptors/TimeMeasureAdaptor.hpp"

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: PerformanceTest.hpp,v 1.8 2004/12/30 12:48:48 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class PerformanceTest : public VThread  
{
public:
	// iTest: 1 = spatial
	//		  2 = color
	//		  3 = quality
	//		  4 = temporal
	//		  5 = strong temporal
	PerformanceTest(VideoESInfo *pESInfo, ContainerInfo *pContainerFile, 
		int iTest,MP4Decoder::meCoderType codec=MP4Decoder::FFMPEG);
	~PerformanceTest();

	void run();
	u32 getDecodeTimeInMicroSecs() const { return muiDecodeTime;};
	u32 getAdaptTimeInMicroSecs() const { return muiAdaptTime;};
	u32 getEncodeTimeInMicroSecs() const { return muiEncodeTime;};

private:
	AdaptorChain *mpAdaptorChain;
	VideoESInfo *mpESInfo;
	ContainerInfo *mpContainerFile;

	// in usecs
	u32 muiDecodeTime;
	u32 muiAdaptTime;
	u32 muiEncodeTime;

};

#endif // !defined(AFX_PERFORMANCETEST_H__8595BD5E_844F_4792_B650_C3B2773AB34B__INCLUDED_)
