 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	mp7creator.cpp                                                *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "metadata/MP7File.hpp"
#include "container/ContainerFile.hpp"
#include "ContainerInfo.hpp"

int main(int argc, char *argv[])
{
	if (argc != 3) {
		printf("\nUsage:\n----------------\nmp7creator input.mp4 output.xml\n");
		return 0;
	}

	ContainerInfo *mp4File = ContainerFile::loadContainerInfo(argv[1]);
	if (!mp4File) {
		printf("mp7creator: Couldn't find mp4 file\n");
		printf
	    ("\nUsage:\n----------------\nmp7creator input.mp4 output.xml\n");
		return 0;
	}
	char *retVal = MP7File::generateMP7Description(mp4File, argv[2], true);
	if (!retVal) {
		printf("Failed to generate MP7 desription\n");
	}
	delete mp4File;
	return 0;
};
