#include <MP7Parser.hpp>
#include <stdio.h>
#include <iostream>
#include <string>
#include <iomanip>
using namespace std;


int main ()
{


	FILE *filehandle = MP7Parser::MP7Open("validated_mpeg7.xml");
	if (filehandle == NULL) {
		cout << "MP7Open not successful" << endl;
		exit(1);
	}



	MP7Parser::MP7_VarDescrData vardescrdata = MP7Parser::MP7GetVarDescrData(filehandle);                                         
                                                                                                                                   
	if (vardescrdata.errorcode == ERR__OK) {
  
                                                                                                                            
         MP7Parser::MP7_VarSetList *tmp_vlspointer = vardescrdata.vsl_pointer;                                                     
                                                                                                                                   
         cout << "MP7GetVarDescrData successful" << endl;                                                                          
                                                                                                                                   
         while (tmp_vlspointer != NULL) {                                                                                          
             cout << std::endl << "Source data:" << endl;                                                                          
             cout << "\t" <<"id = '"             << tmp_vlspointer->sdata.id             << "'" << endl;                           
             cout << "\t" <<"video_codec = '"    << tmp_vlspointer->sdata.video_codec    << "'" << endl;                           
             cout << "\t" <<"video_height = '"   << tmp_vlspointer->sdata.video_height   << "'" << endl;                           
             cout << "\t" <<"video_width = '"    << tmp_vlspointer->sdata.video_width    << "'" << endl;                           
             cout << setprecision(4)                                                                                               
                 << "\t" <<"video_rate = '"      << tmp_vlspointer->sdata.video_rate     << "'" << endl;                           
             if (tmp_vlspointer->sdata.has_audio) {                                                                                
                 cout << "\t" << "Source has Audio" << endl;                                                                       
                 cout << "\t" <<"audio_codec = '"    << tmp_vlspointer->sdata.audio_codec    << "'" << endl;                       
             }                                                                                                                     
             else {                                                                                                                
                 cout << "\t" << "Source has no Audio" << endl;                                                                    
             }                                                                                                                     
             cout << "\t" <<"fileformat = '" << tmp_vlspointer->sdata.fileformat << "'" << endl;                                   
             cout << "\t" <<"filesize = '"   << tmp_vlspointer->sdata.filesize   << "'" << endl;                                   
             cout << "\t" <<"bitrate = '"    << tmp_vlspointer->sdata.bitrate    << "'" << endl;                                   
             cout << "\t" <<"path = '"       << tmp_vlspointer->sdata.path       << "'" << endl;                                   
             cout << "\t" <<"Number of Variations: "                                                                               
                                             << tmp_vlspointer->nr_variations    << "'" << endl;                                   
                                                                                                                                   
	     MP7Parser::MP7_VarList *tmp_vlpointer = tmp_vlspointer->vdata.var_list;                                                   
                                                                                                                                   
             while (tmp_vlpointer != NULL) {                                                                                       
                     cout << endl << "\t\t" << "Variation data:"     << endl;                                                      
                     cout << "\t\t" << "variation_id = '"    << tmp_vlpointer->vdata.variation_id    << "'" << endl;               
                     cout << setprecision(4)                                                                                       
                          << "\t\t" << "fidelity = '"        << tmp_vlpointer->vdata.fidelity        << "'" << endl;               
                     cout << "\t\t" << "priority = '"        << tmp_vlpointer->vdata.priority        << "'" << endl;               
                     cout << "\t\t" << "id = '"              << tmp_vlpointer->vdata.id              << "'" << endl;               
                     cout << "\t\t" << "video_codec = '"     << tmp_vlpointer->vdata.video_codec     << "'" << endl;               
                     cout << "\t\t" << "video_height = '"    << tmp_vlpointer->vdata.video_height    << "'" << endl;               
                     cout << "\t\t" << "video_width = '"     << tmp_vlpointer->vdata.video_width     << "'" << endl;               
                     cout << setprecision(4)                                                                                       
                          << "\t\t" << "video_rate = '"      << tmp_vlpointer->vdata.video_rate      << "'" << endl;               
                     if (tmp_vlpointer->vdata.has_audio) {                                                                         
                         cout << "\t\t" << "Source has Audio"<< endl;                                                              
                         cout << "\t\t" << "audio_codec = '" << tmp_vlpointer->vdata.audio_codec     << "'" << endl;               
                     }                                                                                                             
                     else {                                                                                                        
                         cout << "\t\t" << "Source has no Audio" << endl;                                                          
                     }                                                                                                             
                     cout << "\t\t" << "fileformat = '"      << tmp_vlpointer->vdata.fileformat      << "'" << endl;               
                     cout << "\t\t" << "filesize = '"        << tmp_vlpointer->vdata.filesize        << "'" << endl;               
                     cout << "\t\t" << "bitrate = '"         << tmp_vlpointer->vdata.bitrate         << "'" << endl;               
                     cout << "\t\t" << "path = '"            << tmp_vlpointer->vdata.path            << "'" << endl;               
                     cout << "\t\t" << "variation_relationship = '" << tmp_vlpointer->vdata.variation_relationship << "'" << endl; 
                     tmp_vlpointer = tmp_vlpointer->next;                                                                          
             }                                                                                                                     
             tmp_vlspointer = tmp_vlspointer->next;                                                                                
         }                                                                                                                         
     }                                                                                                                             
     else {                                                                                                                        
         cout << "MP7GetVarDescrData not successful, Errorcode: " << vardescrdata.errorcode << endl;                               
     	}                                                                                                                             


	bool closed = MP7Parser::MP7Close(filehandle);
	if (!closed) {
		cout << "MP7Close not successful" << endl;
		exit(1);
	}

	return 0;

}
