

#include <afxwin.h> 
#include "simpleplayer.hpp"
#include <string.h>

#include "vitooki.hpp"
#include "global.hpp"


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	int PARAM_SIZE = 1024;
	M3SMetaInfo *m3s = NULL;
	char *param = new char[PARAM_SIZE];
	char *tmp = NULL;
	char *filename = NULL;

	if (strlen((char*)lpCmdLine) > PARAM_SIZE) {
		dprintf_err_fatal("\nsimpleCE::Main() param size too long (%d) - maximum allowed: %d\n", strlen((char*)lpCmdLine), PARAM_SIZE);
		return -1;
	}

#ifdef UNICODE
  WideCharToMultiByte(CP_ACP, 0, lpCmdLine, -1, param, PARAM_SIZE, NULL, NULL);
#else
  strcpy(param, lpCmdLine);
#endif 

	vitooki_init_all();


	if (strlen(param) != 0) {
		dprintf_full("\nsimpleCE::Main() param = %s\n", param);
		
		if (strstr(param, ".m3s") != NULL || strstr(param, ".M3S") != NULL) {
			m3s = new M3SMetaInfo();
			if (strstr(param, "http://") == NULL) {
				if (!m3s->loadFromFile(param)) {
					dprintf_err("\nsimpleCE::Main() cannot load m3s-file!");
					return -1;
				}
			} else {
				if (!m3s->loadFromURL(param)) {
					dprintf_err("\nsimpleCE::Main() cannot load url!");
					return -1;
				}
			}


			int k = strlen(param);
			while (--k >= 0) {
				if (param[k] == '\\') break;
			}

			if (strstr(param, "http://") != NULL) {

				char *slashPos = strstr(param + strlen("http://") + 1, "/");

				if (slashPos != NULL) {
					char *lastSlashPos = slashPos;
					while ((slashPos = strstr(slashPos + 1, "/")) != NULL) lastSlashPos = slashPos;

					if (strstr(m3s->getVideoFilepath(), "http://") == NULL) {
						m3s->appendVideoFilepath(PARAM_SIZE, param, (lastSlashPos+1)-param);
					}
					
					if (strstr(m3s->getAudioFilepath(), "http://") == NULL) {
						m3s->appendAudioFilepath(PARAM_SIZE, param, (lastSlashPos+1)-param);
					}
				}
			}
			else if (k > 0) {
				
				if (m3s->getVideoFilepath()[0] != '\\' && strstr(m3s->getVideoFilepath(), "http://") == NULL) {
					m3s->appendVideoFilepath(PARAM_SIZE, param, k+1);
				}
				
				if (m3s->getAudioFilepath()[0] != '\\' && strstr(m3s->getAudioFilepath(), "http://") == NULL) {
					m3s->appendAudioFilepath(PARAM_SIZE, param, k+1);
				}
			}

		} else {
			filename = param;
			dprintf_full("used file: %s\n", filename);
		}


	} else {
		dprintf_full("\nsimpleCE::Main() no param");
	}

	Simpleplayer *sp = new Simpleplayer(filename, false, true, false, true, false, false, true, false, false, 240, 320, m3s);
	sp->startPlayer();

	delete [] param;

	if (tmp != NULL) delete [] tmp;

	return 0;
}

