// vitookitestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vitookitest.h"
#include "vitookitestDlg.h"
//#include "SDL.h"

#include "vitooki.hpp"
#include "global.hpp"
#include "io/MPGStreamIO.hpp"
#include "ESInfo.hpp"
#include "VideoESInfo.hpp"
#include "DataChannel.hpp"
#include "io/YUVStreamIO.hpp"
#include "DataChannel.hpp"
#include "DataSink.hpp"
#include "adaptors/MP4Decoder.hpp"
#include "io/SDLRenderer.hpp"
#include "io/RawStreamIO.hpp"
#include "AudioESInfo.hpp"
#include "adaptors/MadMP3Decoder.hpp"
#include "io/SDLaudioIO.hpp"
#include "ReferenceCounter.hpp"
#include "adaptors/SharedAdaptor.hpp"
#include "adaptors/ESSynchronizer.hpp"
#include "adaptors/GlobalTimer.hpp"
#include "VideoAdaptorChain.hpp"
#include "AudioAdaptorChain.hpp"
#include "io/BufferedMPGStreamReader.hpp"
#include "io/BufferedMPGStreamReader2.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVitookitestDlg dialog

CVitookitestDlg::CVitookitestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVitookitestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVitookitestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVitookitestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVitookitestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVitookitestDlg, CDialog)
	//{{AFX_MSG_MAP(CVitookitestDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVitookitestDlg message handlers

BOOL CVitookitestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	vitooki_init_codecs();


//	GlobalTimer *gt = new GlobalTimer(); //used for video+audio stream
//	ReferenceCounter *ref = new ReferenceCounter(); //used for video+audio stream


	
	VideoESInfo *ves = new VideoESInfo(1, 
							CODEC_TYPE_VIDEO,
							NULL, 
							90000/15,
							NULL,
							0,
							0,
							300000, //182000,
							0,
							90000,
							90000 * 25, //25 sec
							0, //size
							240,
							320,
							true,
							true,
							CODEC_ID_MPEG4,
							0.0,
							320/240,
							true,
							50,
							0,
							0);


//	AdaptorChain* vidChain = new VideoAdaptorChain();

	//MPGStreamIO *mpgstream = new MPGStreamIO(ves, "shuttle15fps-75_rotate.m4v", false);
	BufferedMPGStreamReader2 *mpgstream = new BufferedMPGStreamReader2(ves, "shuttle15fps-75_rotate.m4v", false, false, 1048576); //4000); //65536);
	//BufferedMPGStreamReader *mpgstream = new BufferedMPGStreamReader(ves, "eiffel-en-10fps-300-00.m4v", false, false, 1048576); //4000); //65536);
	//BufferedMPGStreamReader *mpgstream = new BufferedMPGStreamReader(ves, "shuttle.m4v", false, false, 1048576); //65536);
	//MPGStreamIO *mpgstream = new MPGStreamIO(ves, "shuttle.m4v", false);

	MP4Decoder *mp4dec = new MP4Decoder(ves);




//	vidChain->addAdaptor(mp4dec);
//	vidChain->addAdaptor(new SharedAdaptor(ref, (Adaptor*&)gt));
//	ESSynchronizer *esync = new ESSynchronizer(ves, gt);
//	vidChain->addAdaptor(esync);


	DataChannel *vdc = new DataChannel(mpgstream,ves); //,vidChain);


	


	SDLRenderer *sdl = new SDLRenderer(ves, 
		UncompressedVideoFrame::ColorSpaceI420, 
								240, //240,
								320, 
								true, //fullscreen
								false, //pullevents
								false, //islabelresizeable
								true, //fixaspectratio
								false, //allowupscalex
								false); //rotatex

	DataSink *vds = new DataSink(1, sdl, "127.0.0.1", 0, mp4dec);


	vdc->insert(vds);
	vdc->play(1,0.0);
	//*dc->insert(ads);
	//dc->play(2, 0.0);


/*



	AudioESInfo *aes = new AudioESInfo(2, //streamid
								CODEC_TYPE_AUDIO, //streamtype
								NULL, //vob
								2351, //90000/2500,  //time-increment
								NULL, //encodeddecconf
								0, //objtype
								0, //bufsize
								64000, //avgBW
								0, //maxBW
								90000, //timeScale
								90000 * 25.57, //duration
								0, //size
								44100, //samplerate
								2, //numaudiochannels
								true, //complete
								CODEC_ID_MP3, //codec_id
								0.0, //quality
								32); //bitsPerSample


	AdaptorChain* audChain=new AudioAdaptorChain();


	//RawStreamIO *rawstream = new RawStreamIO(aes, "deiche.mp3", false);
	BufferedMPGStreamReader *rawstream = new BufferedMPGStreamReader(aes, "shuttle-audio-64kbps-mono.mp3", false, false, 1048576, 32768); //2048);
	//RawStreamIO *rawstream = new RawStreamIO(aes, "eminem.mp3", false);
	//MPGStreamIO *rawstream = new MPGStreamIO(aes, "eminem.mp3", false);
	//rawstream->setFrameSize(MAD_INPUT_BUFFER_SIZE/4);
	//rawstream->setFrameSize(1152);
//	rawstream->setFrameSize(1600);
	//rawstream->setFrameSize(MAD_INPUT_BUFFER_SIZE/40); //5*8192

	MadMP3Decoder *mad = new MadMP3Decoder(aes);

	

	

	


	audChain->addAdaptor(mad);
	audChain->addAdaptor(new SharedAdaptor(ref, (Adaptor*&)gt));


	DataChannel *adc = new DataChannel(rawstream, aes, mad); //, audChain);
	SDLaudioIO *sdlaudio = new SDLaudioIO(aes, esync);
//	SDLaudioIO *sdlaudio = new SDLaudioIO(aes);
	
	DataSink *ads = new DataSink(2, sdlaudio, "127.0.0.1");


	adc->insert(ads);
	adc->play(2, 0.0); 

	esync->setPaused(false);
*/

	DWORD timemillis1 = timeGetTime();


	vdc->run();
/*	adc->start();

	
	//adc->run(); //dc->run();


	bool quit = false;
	while ( !quit  ) {
		if (!adc && !vdc->running() ) { //video stops
			if (adc)
				adc->teardown(2, true);
			quit = true;
		}
		
		
		if (adc && !adc->running() ) { //audio stops
			vdc->teardown(1, true);
			break;
			quit = true;
		}
		Sleep(1);
	}*/




	DWORD timemillis2 = timeGetTime();

	DWORD dist = timemillis2 - timemillis1;
	CString str;
	str.Format(_T("dist=%d ms"), dist);
	AfxMessageBox(str,0,0);




	/*DWORD timemillis1 = timeGetTime();

	//dc->run();

	DWORD timemillis2 = timeGetTime();

	DWORD dist = timemillis2 - timemillis1;
	CString str;
	str.Format(_T("dist=%d ms"), dist);
	AfxMessageBox(str,0,0);*/


	delete vds;
	delete sdl;
	delete vdc;
	delete mp4dec;
	delete mpgstream;
	delete ves;

	/*
	delete ads;
	delete sdlaudio;
	delete adc;
	delete mad;
	delete rawstream;
	delete aes;*/

	/*
	if (mpgstream->open()) {
		AfxMessageBox(_T("open ok"), 0, 0);
	} else {
		AfxMessageBox(_T("open NOK!"), 0, 0);
	}*/


	
	/*if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		AfxMessageBox(_T("SDL NOK!"), 0, 0);
	}


	SDL_Surface *screen;

	screen = SDL_SetVideoMode( 240, 320, 16, SDL_SWSURFACE );
	if ( screen == NULL )
	{
		AfxMessageBox(_T("video NOK!"), 0, 0);
	} else {
		AfxMessageBox(_T("video ok!"), 0, 0);
	}

	SDL_Surface *image = SDL_LoadBMP("lakesidewince.bmp");


    SDL_BlitSurface(image, NULL, screen, NULL);
    SDL_FreeSurface(image);
    SDL_UpdateRect(screen, 0, 0, 0, 0);

	Sleep(2000);*/

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


