##############
# TO BE INCLUDED FROM A apps/myapp or examples/myapp Makefile!
##############

include $(BASEDIR)/rules.mk


INCLUDES  += -I$(BASEDIR)/src

LDFLAGS   += -L$(BASEDIR)/src/.libs -lvitooki-base -lvitooki-adaptors 
LDFLAGS   += -lvitooki-cache -lvitooki-container -lvitooki-io
LDFLAGS   += -lvitooki-metadata -lvitooki-net


UI_FILES    = $(wildcard *.ui)
UIC_CPP_FILES   = $(subst .ui,.cpp,$(UI_FILES))
UIC_HPP_FILES = $(subst .ui,.hpp,$(UI_FILES))
UIC_OBJECTS = $(subst .ui,.o,$(UI_FILES))

MOC_SRC	=	$(patsubst %.hpp,moc_%.cpp, $(shell grep -l Q_OBJECT *.hpp 2>/dev/null))
MOC_SRC	+=	$(patsubst %.ui,moc_%.cpp, $(UI_FILES))
HEADERS   = $(wildcard *.hpp)  $(UIC_HPP_FILES) 
SRC       = $(sort  $(wildcard *.cpp) $(MOC_SRC) $(UIC_CPP_FILES)) 
OBJECTS   = $(subst .cpp,.o,$(SRC)) $(subst .c,.o,$(wildcard *.c)) $(EXTRA_OBJECTS)

BIN	  = $(shell basename `pwd`)

all:  $(BIN)

Makefile: Makefile.dep

Makefile.dep:     $(HEADERS) $(SRC)
	$(GCC) $(INCLUDES) -M $(SRC) > Makefile.dep

include Makefile.dep


$(BIN):   $(OBJECTS)
	$(CPP) $(CPPFLAGS) $(OBJECTS) $(LDFLAGS) -o $@


clean:
	rm -f $(BIN) *.o *~ Makefile.dep
	rm -f $(UIC_HPP_FILES) $(UIC_CPP_FILES) $(MOC_SRC)

install:
	@echo "installing $(BIN) binary"
	cp $(BIN) $(PREFIX)/bin

uninstall:
	@echo "removing $(BIN) binary"
	rm -f $(PREFIX)/bin/$(BIN)
