 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	AudioAdaptorChain.cpp                                         *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "AudioAdaptorChain.hpp"
#include "AudioFrame.hpp"

AudioAdaptorChain::AudioAdaptorChain() : AdaptorChain()
{
	strcpy(name,"AudioAdaptorChain");
	es=NULL;
}

AudioAdaptorChain::~AudioAdaptorChain()
{
   
}


void AudioAdaptorChain::setESInfo(ESInfo * esi)
{
	es=(AudioESInfo*)esi;
	list < Adaptor * >::iterator adaptorIterator;

	for (adaptorIterator = mAdaptorList.begin();
		adaptorIterator != mAdaptorList.end(); adaptorIterator++) {
		(*adaptorIterator)->setESInfo(esi);
	}
};

ESInfo * AudioAdaptorChain::getESInfo()
{
	if(mAdaptorList.empty())
		return NULL;
	return mAdaptorList.front()->getESInfo();
};

Adaptor *AudioAdaptorChain::clone()
{
    AdaptorChain *adapt = new AudioAdaptorChain();
	
    list < Adaptor * >::iterator adaptorIterator;
    for (adaptorIterator = mAdaptorList.begin();
	adaptorIterator != mAdaptorList.end(); adaptorIterator++) {
		adapt->addAdaptor((*adaptorIterator)->clone());
    }
    return adapt;
}

