 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	Frame.cpp                                                     *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

/**
 * Frame.cpp 
 * ========= 
 * 
 * Decr:    Implementation of concrete methods of the abstract class  
 *          GOP 
 * Version: 0.001 
 * Author:  K. Leopold 
 *  
 * Known Bugs: 
 *   -  
 * 
 * ToDo: 
 *   -  
 * 
 ****************/

#include "Frame.hpp"


/** 
 * Constructor with type 
 * ----------- 
 */
Frame::Frame(FrameType t) {
    accessUnit = NULL;
		
		mediaTimeScale = 0;
		streamID = 0;
		markedForDelete = false;
		setType(t);
}


Frame::~Frame() {
  if (accessUnit) {
    dprintf_full("Frame::~Frame: Frame %p destruct... delete accessUnit AU %p of size %i\n",this,accessUnit,accessUnit->size);
    delete accessUnit;
    accessUnit=NULL;
  }
}


bool Frame::setAU(AU * auTemp, bool detectType) {
  if (!auTemp)
    return false;
  if (accessUnit)
    delete accessUnit;
  
  accessUnit = auTemp;
  
  
  //default YUV pointers into payload, on WINCE will be overridden by setAUy/u/v()
  accessUnit->y = accessUnit->payload;
  accessUnit->u = accessUnit->payload; //FIXME: not known: + width+height
  accessUnit->v = accessUnit->payload; //FIXME: not known: + width+height *1.25
  
  
  if (detectType)
    detectFrameType();
  
  return true;
}


bool Frame::unsetAU() {
  if (!accessUnit)
    return false;
  
  accessUnit = NULL;
  return true;
}
