/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   ObjectDescriptorESInfo.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/
 
#ifndef PS_ODELEMENTARYSTREAMINFO_HPP
#define PS_ODELEMENTARYSTREAMINFO_HPP

#include "ESInfo.hpp"

class ObjectDescriptorESInfo: public ESInfo
{
public:
	/** creates an AudioESInfo object
		* @param encodeddecconf is only shallow copied and
		* freed in the destructor
		* @param avgBW and @param maxBW specify the bandwidth of the given ES
		* and are in Bits/sec !
	*/
	ObjectDescriptorESInfo(u32 streamId, u32 streamtype, ContainerInfo * vob, u32 timeIncrement,
				 u8 * encodeddecconf, u32 objtype, u32 bufsize,
				 u32 avgBW, u32 maxBW, u32 timeScale,
				 u64 duration, u32 size,  bool complete=true, 
				 CodecID codec_id = CODEC_ID_MPEG4, float quality = 1.0);
	
	virtual ~ObjectDescriptorESInfo();

	u32 getHandlerType() const;

	bool isVisualStream() const;

	bool isAudioStream() const;

	bool isODStream() const;

	bool isSceneDescriptionStream() const;
	
	void generateDescriptionText();
  /** creates a deep copy of the ES */
	ESInfo *clone(ContainerInfo * mp4);
};
#endif



 
