#include "SessionCounter.hpp"
#include <assert.h>

SessionCounter::SessionCounter(const char* filenam) : VThread()
{
	assert(filenam);
	strcpy(this->filename,filenam);
	this->counter=0;
	this->incr=0;
	this->decr=0;
	this->stopped=false;
	imutex.initialize("SessionCounterImutex");
	dmutex.initialize("SessionCounterDmutex");
}

SessionCounter::~SessionCounter()
{
	imutex.destroy();
	dmutex.destroy();
}
void SessionCounter::increment()
{
	imutex.lock();
	incr+=1;
	imutex.release();
}

void SessionCounter::decrement()
{
	dmutex.lock();
	decr+=1;
	dmutex.release();
}

void SessionCounter::stop()
{
	this->stopped = true;
}
void SessionCounter::run()
{
	timeval currentTime,startTime;
	if(filename==NULL) {
		this->exit();
		return;
	}
	FILE* file = fopen(this->filename,"w+");
	if(file) {
		gettimeofday(&startTime,NULL);
		for (unsigned int i = 0 ; !stopped ; i++)
		{
			if(gettimeofday(&currentTime,NULL) == 0)
			{
				fprintf(file,"%u %ld %u %u %u\n",i,currentTime.tv_sec,this->incr-this->decr,this->incr,this->decr);
				fflush(file);
				sleep(1);
			}
		}
		fclose(file);
	}
 	this->exit();
}
