 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	Forwarder.hpp                                                 *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_FORWARDER_HPP
#define _PS_FORWARDER_HPP
#include "Adaptor.hpp"
#include "Frame.hpp"

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: Forwarder.hpp,v 1.8 2006/01/20 15:37:17 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class Forwarder : public Adaptor {
public:
	list < Frame * >adapt(Frame * frm) {
		list < Frame * >tmp;
		tmp.push_front(frm);
		//		dprintf_full("Forwarder::adapt doing nothing to frame cts %i\n",frm->getAU()->cts);
		return tmp;
	};
	Adaptor *clone() {
		return new Forwarder();
	};

	void initialize() {;
	};
	Forwarder() { strcpy(name,"Forwarder");
	};
	virtual ~ Forwarder() {
	};
	/** Sets a reference to an ESInfo object. Adaptors are
	allowed to change ESInfo objects. If you don't want that,
	pass an es->clone() 
	*/ 
	void setESInfo(ESInfo * esi){;};
	ESInfo * getESInfo() { dprintf_err("Forwarder::getESInfo calling this is stupid!!\n"); return NULL;};
	/** returns adaptation costs (CPU only) */
	u32 getTranscodingCosts() const {
		return 0u;
	}

};
#endif
