 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	FrameCounter.hpp                                              *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _MK_FRAMECOUNTER_HPP
#define _MK_FRAMECOUNTER_HPP
#include "Adaptor.hpp"
#include "Frame.hpp"
#include "ESInfo.hpp"

class Statistics;

/**
 * Adaptor class FrameCounter counts by-passing frames and
 * should be installed close before or after decoding and displaying
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: FrameCounter.hpp,v 1.6 2006/01/20 15:37:17 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class FrameCounter : public Adaptor {
public:

	/* Constructor
	*/
	FrameCounter(ESInfo* esi, Statistics *statistics);
	
	virtual ~FrameCounter();
	
	list < Frame * >adapt(Frame * frm);
	
	Adaptor *clone() { return new FrameCounter(es,stats);	};

	void initialize();
	
	list < Frame * >close() {
		list < Frame * >tmp;
		return tmp;
	};

	/** Sets a reference to an ESInfo object. Adaptors are
		allowed to change ESInfo objects. If you don't want that,
		pass an es->clone() 
	*/ 
	void setESInfo(ESInfo * esi) {es=esi;};
	ESInfo * getESInfo() { return es;}
	/** returns adaptation costs (CPU only) */
	u32 getTranscodingCosts() const{
		return 1000;
	}
private:
protected:
	ESInfo* es;

	Statistics *stats;
	u32	currentFrameNumber;
};
#endif

