 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	QualityReductionAdaptor.cpp                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "QualityReductionAdaptor.hpp"

QualityReductionAdaptor::QualityReductionAdaptor(VideoESInfo * pESInfo,
						 u32 uiTargetBitrate,
						 u32 key,MP4Decoder::meCoderType code)
{
	es = pESInfo;
	targetBitrate = uiTargetBitrate;
	keyFrameInterval = key;
	initialized = false;
	strcpy(name,"QualityReductionAdaptor");
	codec=code;
}

void
 QualityReductionAdaptor::initialize()
{
	if(initialized)
		return;
	dprintf_full("QualityReductionAdaptor::initialize() Codec %i\n",codec);
  addAdaptor(new MP4Decoder(es, false, UncompressedVideoFrame::ColorSpaceI420,codec));
  addAdaptor(new MP4Encoder(es, targetBitrate, (int)es->getFPS(), keyFrameInterval, 0 /*BVOPs*/, UncompressedVideoFrame::ColorSpaceI420,codec));
  initialized = true;
};

QualityReductionAdaptor::~QualityReductionAdaptor()
{
}

Adaptor *QualityReductionAdaptor::clone()
{
    return new QualityReductionAdaptor(es, targetBitrate,keyFrameInterval,codec);
}
