 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	SpatialReductionAdaptor.cpp                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "SpatialReductionAdaptor.hpp"

SpatialReductionAdaptor::SpatialReductionAdaptor(VideoESInfo * pESInfo,
						 u32 * puiWidth,
						 u32 * puiHeight,
						 u32 uiTargetBitrate,
						 u32 key,MP4Decoder::meCoderType code)
{
    es = pESInfo;
    initialized = false;
    keyFrameInterval = key;
    width = *puiWidth;
    height = *puiHeight;
    targetBitrate = uiTargetBitrate;
		strcpy(name,"SpatialReductionAdaptor");
		codec=code;
}

void
 SpatialReductionAdaptor::initialize()
{
	if(this->mAdaptorList.empty()) {
    addAdaptor(new MP4Decoder(es,false,UncompressedVideoFrame::ColorSpaceI420,codec));
    addAdaptor(new YUVSpatialReductionAdaptor(es, &width, &height));
    addAdaptor(new MP4Encoder(es, targetBitrate, (int)es->getFPS(), keyFrameInterval, 0 /*BVOPs*/,UncompressedVideoFrame::ColorSpaceI420,codec));
	}
  initialized = true;
};

SpatialReductionAdaptor::~SpatialReductionAdaptor()
{
}


Adaptor *SpatialReductionAdaptor::clone()
{
    return new SpatialReductionAdaptor(es, &width, &height, targetBitrate,keyFrameInterval,codec);
}
