 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	YUVColorReductionAdaptor.cpp                                  *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "YUVColorReductionAdaptor.hpp"
#include "string.h"


YUVColorReductionAdaptor::YUVColorReductionAdaptor(VideoESInfo * pESInfo)
{
		this->es=pESInfo;
		initialized=false;
		strcpy(name,"YUVColorReductionAdaptor");
}

void
 YUVColorReductionAdaptor::initialize()
{
	es->setHasColor(false);
	muiUVStart = es->getWidth() * es->getHeight();
  muiUVSize = (es->getWidth() / 2) * (es->getHeight() / 2) * 2;
  initialized = true;
};

YUVColorReductionAdaptor::~YUVColorReductionAdaptor()
{
}

list < Frame * >YUVColorReductionAdaptor::adapt(Frame * frm)
{
	if(!initialized)
		initialize();

	list < Frame * >retFrameList;

	memset(frm->getAU()->payload + muiUVStart, 128, muiUVSize);

	retFrameList.push_back(frm);

	return retFrameList;

}

list < Frame * >YUVColorReductionAdaptor::close()
{
    list < Frame * >retFrameList;
    return retFrameList;
}

Adaptor *YUVColorReductionAdaptor::clone()
{
    return new YUVColorReductionAdaptor(es);
}


