/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:   ContainerFile.hpp                                           *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/
#ifndef VITOOKI_CONTAINERFILE_HPP_
#define VITOOKI_CONTAINERFILE_HPP_
 
#include "global.hpp"

class ContainerInfo;
class ESInfo;
class Adaptor;
class Url;

/**
 *
 * <Class Description goes here>
 *
 *@author Peter Schojer
 *
 *@version $Id: ContainerFile.hpp,v 1.5 2006/02/24 08:17:31 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class ContainerFile {
public:

/* There are three methods for obtaining stream parameters
 * only needed for (incomplete headers of) .MP4 files
 * RUN_THROUGH - read the entire file and build statistics: very accurate and very slow
 * ESTIMATE1 - obtain some parameters from ffmpeg and calculate the others
 * 	       (will not work for VBR audio or containers with multiple video streams
 * 	       not very accurate but very fast
 * ESTIMATE2 - read MAX_TEST_DURATION frames and calculate the parameters(will work for all 
 *             types of containers: not very accurate but it is fast
 */
enum ParseType {
	RUN_THROUGH,
	ESTIMATE1,
	ESTIMATE2
};
	
	/** init. a video object from a pre-stored ContainerFile. 
	 * No data is read, just metainfo
	 */
	static ContainerInfo *loadContainerInfo(const char *fileName, Url* uri=NULL,
																					const ParseType type = ESTIMATE1);
	
	/** FIXME not implemented: multiplexes a set of ES to a ISOMP4ContainerFile */
	static bool saveToContainerFile(const char *fileName, ContainerInfo *ci);
};
#endif
