 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: ISOMP4ContainerFile.hpp                                       *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_ISOMP4CONTAINERFILE_
#define _PS_ISOMP4CONTAINERFILE_

#ifdef ISOMP4

#include "global.hpp"

#include "ISOMovies.h"

class ContainerInfo;
class ESInfo;
class Adaptor;
class Url;

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: ISOMP4ContainerFile.hpp,v 1.4 2005/03/26 20:17:26 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class ISOMP4ContainerFile {
  public:

    /** init. a videoobject from a pre-stored ISOMP4ContainerFile. No data is read, just meta-
      * info
      */
    static ContainerInfo *loadContainerInfo(const char *fileName, const Url* uri=NULL);

    /** FIXME not implemented: multiplexes a set of ES to a ISOMP4ContainerFile */
    static bool saveToContainerFile(const char *fileName, ContainerInfo *ci) {
			return false;
    };

  private:
    static ESInfo *loadESInfo(ISOMovie & moov, ContainerInfo * vob,
			      u32 streamId);

};

#endif
#endif
