#ifndef WIN32

/***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: MKContainerFile.hpp                                             *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/
#ifndef VITOOKI_MKCONTAINERFILE_HPP_
#define VITOOKI_MKCONTAINERFILE_HPP_

/**
 *
 * <Class Description goes here>
 *
 *@author Armin Mueller
 *
 *@version $Id: MKContainerFile.hpp,v 1.4 2006/02/11 16:35:00 klschoef Exp $
 *
 *@short <short description>
 *
 */


#include "global.hpp"
#include "ESInfo.hpp"
#include "debug.hpp"
#include "VideoESInfo.hpp"
#include "AudioESInfo.hpp"

#include "MatroskaParser.h"

#include <stdio.h>
#include <string.h>


#ifdef __cplusplus
extern "C" {
//#include "avformat.h"
}
#endif

class ContainerInfo;
class ContainerFile;
class ESInfo;
class Adaptor;
class Url;

class MKContainerFile{


public:
	
	/** init. a video object from a pre-stored ContainerFile. 
	 * No data is read, just metainfo
	 */
	static ContainerInfo *loadContainerInfo(const char *fileName, const Url* uri=NULL);
	
	/** 
	 *
	 */
	static bool saveToContainerFile(const char *fileName, ContainerInfo *ci);

private:
	static ESInfo *loadESInfo(ContainerInfo * vob, int streamIndex, MatroskaFile *mf);


};//MKContainerFile

#endif

#endif





