 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	Video4LinuxContainerFile.hpp                                        *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_VIDEO4LINUXCONTAINERFILE_
#define _PS_VIDEO4LINUXCONTAINERFILE_

#ifdef ENABLE_FFMPEG

#include "global.hpp"
#include "ContainerFile.hpp"

#ifdef __cplusplus
extern "C" {
#include "avformat.h"
}
#endif

class ContainerInfo;
class ContainerFile;
class ESInfo;
class Adaptor;
class Url;

#define MAX_TEST_DURATION 50.0

/**
 *
 * <Class Description goes here>
 *
 *@author Martin Prangl
 *
 *@version $Id: Video4LinuxContainerFile.hpp,v 1.1 2005/07/18 15:55:52 mprangl Exp $
 *
 *@short <short description>
 *
 */
class Video4LinuxContainerFile {
public:
	
	/** init. a videoobject from a Video4Linux (v4l) device. No data is read, just meta-
		* info
		*/
	static ContainerInfo *loadContainerInfo();

	/** FIXME not implemented: multiplexes a set of ES to a ISOMP4ContainerFile */
	static bool saveToContainerFile(char *fileName) {
		return false;
	};

 
private:

	static int getStreamParameters();
	static ESInfo *loadESInfo(AVFormatContext * ic, ContainerInfo * vob, int streamIndex);
	
};

#endif
#endif
