 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	ffMP4ContainerFile.hpp                                        *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_FFMP4CONTAINERFILE_
#define _PS_FFMP4CONTAINERFILE_

#ifdef ENABLE_FFMPEG

#include "global.hpp"
#include "ContainerFile.hpp"

#ifdef __cplusplus
extern "C" {
#include "avformat.h"
}
#endif

class ContainerInfo;
class ContainerFile;
class ESInfo;
class Adaptor;
class Url;

#define MAX_TEST_DURATION 50.0

/**
 *
 * <Class Description goes here>
 *
 *@author Mithilesh Kumar
 *
 *@version $Id: ffMP4ContainerFile.hpp,v 1.9 2005/06/24 07:50:10 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class ffMP4ContainerFile {
public:
enum ParseType {
	RUN_THROUGH,
	ESTIMATE1,
	ESTIMATE2
};
	
	/** init. a videoobject from a pre-stored ISOMP4ContainerFile. No data is read, just meta-
		* info
		*/
	static ContainerInfo *loadContainerInfo(const char *fileName, const Url* uri, 
																					ParseType type);

	/** FIXME not implemented: multiplexes a set of ES to a ISOMP4ContainerFile */
	static bool saveToContainerFile(char *fileName) {
		return false;
	};

 
private:
	static ESInfo *loadESInfo(AVFormatContext * ic, ContainerInfo * vob, int streamIndex);
	static u8 *getDecoderConfiguration(AVFormatContext *ic, int& dcSize, int StreamIndex);
	static int getStreamParameters_run_through(const char *fileName);
	static int getStreamParameters_estimate1(const char *fileName);
	static int getStreamParameters_estimate2(const char *fileName);

};

#endif
#endif
