 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	global.cpp                                                    *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#include "global.hpp"

bool getTimeString(char *timestr, int len) {
#ifdef WINCE
	LPSYSTEMTIME lpst = NULL;
	GetLocalTime(lpst);
	sprintf(timestr, "%d %s %d %s:%s:%s GMT", lpst->wDay,getMonthName(lpst->wMonth), lpst->wYear, 
				addLeadingZeros(lpst->wHour), addLeadingZeros(lpst->wMinute), addLeadingZeros(lpst->wSecond));
#else
	time_t tm;
	time(&tm);
	struct tm lt;
	lt = *localtime(&tm);
	strftime(timestr, len, "%d %b %Y %H:%M:%S GMT", &lt);
#endif

	if (strlen(timestr) <= (unsigned)len) 
		return true;
	else
		return false;
}


unsigned int getFilesize(const char *filename)
{
	unsigned int len = 0;

	if (strstr(filename, "http://") != NULL) {
		len = 0;
		dprintf_err("\nglobal func: getFilesize(%s) cannot determine file size for an url!\n",filename);
	} else {
		FILE *file = fopen(filename, "rb");
		if (file) {
			fseek(file, 0, SEEK_END);
			len = ftell(file);
			fclose(file);
			dprintf_full("\nMKContainerFile::getFilesize(%s) = %d\n", filename, len);
		} else {
			dprintf_err("\nMKContainerFile::getFilesize(%s) cannot open!\n", filename);
		}
	}
	return len;
}
