 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: AudioIO.cpp                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

// Audio.cpp: Implementing the Class AudioIO.
//
//////////////////////////////////////////////////////////////////////

#include "AudioIO.hpp"

#include <stdio.h>
#include <stdlib.h>
#ifndef WINCE
#include <signal.h>
#endif


AudioIO::AudioIO(AudioESInfo *es, ESSynchronizer *ess) : IO() {
	setESInfo(es);
	essync = ess;
	firstFrame=true;
	muiTicksPerSecond = 0;
	es = NULL;
	num_frames =0;
	lastPTSseen = -1;
}

AudioIO::~AudioIO() {
}


void AudioIO::setESInfo(ESInfo * esi) {
	es=(AudioESInfo*)esi;
	muiTicksPerSecond=es->getMediaTimeScale();
	if(muiTicksPerSecond==0)
		muiTicksPerSecond=1;
}


void AudioIO::setTicksPerSecond(u32 uiTicksPerSecond) {
	muiTicksPerSecond = uiTicksPerSecond;
}


bool AudioIO::destroy() {
	return false;
}


int AudioIO::getBufferFillLevel() const {
	return 0;
}


const char *AudioIO::getURL() const {
	return NULL;
}


void AudioIO::setDimension() {
}
