 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	VITMuxDemuxIO.hpp                                               *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _MK_VITMUXDEMUXIO_HPP_
#define _MK_VITMUXDEMUXIO_HPP_

#include "MuxDemuxIO.hpp"
#include "ByteStream.hpp"
#include "container/VITContainerFile.hpp"

class MuxDemuxIO;

/**
 *
 * muxes/demuxes from/to our VIT container to elementary-stream BufferIOs
 *
 *@author Michael Kropfberger
 *
 *@version $Id: VITMuxDemuxIO.hpp,v 1.3 2006/02/24 08:17:32 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class VITMuxDemuxIO:public MuxDemuxIO {

public:

#define VIT_VERSION_NUMBER 1

	/* If writeOnly is true only write access
	 * is permitted, otherwise the file is read-only, url is deep-copied
	 */
	VITMuxDemuxIO(ByteStream *stream);

	virtual ~ VITMuxDemuxIO();


	/** returns a frame and forwards it to the correct BufferIO
	 * This function is typically blocking. Don't use a NULL
	 * return valuse to conclude STREAMEOF, always check with getState()!
	 */
	virtual Frame *getFrame();
	
  /** muxes a frame to the container */
	virtual int writeFrame(Frame * frm,ESInfo *out_es=NULL);


};

#endif
