 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	YUVStreamIO.hpp                                               *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _MK_YUVSTREAMIO_HPP_
#define _MK_YUVSTREAMIO_HPP_

#include "global.hpp"
#include "UncompressedVideoFrame.hpp"
#include "io/RawStreamIO.hpp"
#include "VideoESInfo.hpp"

/**
 *
 * writes YUV frames and sets the correct UncompressedVideoFrame attribs
 *
 *@author Michael Kropfberger
 *
 *@version $Id: YUVStreamIO.hpp,v 1.13 2005/09/22 11:58:44 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class YUVStreamIO : public RawStreamIO {
public:
	/* If @param writeOnly is true only write access
	 * is permitted, otherwise the @param file is read-only, url is deep-copied
	 */
	YUVStreamIO(VideoESInfo * es, const char *file, bool writeOnly);

	/** returns a frame if one complete frame is available, otherwise null 
	 * is returned. This function is typically blocking. Don't use a NULL
	 * return value to conclude STREAMEOF, always check with getState()!
	 */
	Frame *getFrame();
	
	IO *clone() const { return new YUVStreamIO((VideoESInfo*)es,url,writeOnly);};
	

private:
protected:
};

#endif
