 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	MP21.hpp                                                      *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _MPEG4ITEC_MP21_HPP
#define _MPEG4ITEC_MP21_HPP


class UserPreferences;
class TerminalCapabilities;
/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: MP21.hpp,v 1.2 2004/05/04 12:08:37 pschojer Exp $
 *
 *@short <short description>
 *
 */
class MP21 {
private:
	static const char* const openHeader;
	static const char* const closeHeader;
	static const char* const boolStrings[2];

private:
	static const char* getMP21DocumentOpeningHeader();
	static const char* getMP21DocumentClosingHeader();
	/* searches for an integer value in the string @param input, which is
	 * located after @param token. Format of the string-int pair is token="int"
	 */
	static bool findIntAfterToken(const char* input, const char* inputEnd, 
								  const char* token, int* result);

	/** see above, same but for float */
	static bool findFloatAfterToken(const char* input, const char* inputEnd, 
								  const char* token, float* result);

	/* searches for an char* in the string @param input, which is
	 * located after @param token. Format of the string-string pair is token="string"
	 * Make sure result is big enough!
	 */
	static bool findStringAfterToken(const char* input, const char* inputEnd, 
									 const char* token, char* result);
public:

	static char* generateTerminalCapabilityDescription(const TerminalCapabilities* tc);
	/** returns NULL if no openheader is found in the string */
	static TerminalCapabilities* createTerminalCapability(const char* mp21string);

	/** WARNING: this is just a quick hack to make UserPreferences work over network!
	  * There is nothing MPEG-21 or XML in there... BIG FIXME!
		*/
	static char* generateUserPreferencesDescription(const UserPreferences* tc);
	/** FIXME */
	static UserPreferences* createUserPreferences(const char* mp21string);
};
#endif
