 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title: PacketizationLayer.hpp                                        *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PACKETIZATIONLAYER_HPP_
#define _PACKETIZATIONLAYER_HPP_
#include "SyncLayer.hpp"
#include "IO.hpp"

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: PacketizationLayer.hpp,v 1.7 2008/11/24 16:34:59 mtaschwer Exp $
 *
 *@short <short description>
 *
 */
class PacketizationLayer {
public:
  PacketizationLayer();
  virtual ~PacketizationLayer();
  /** splits an AU up in SLPackets */
  virtual SLPacketList createSLPacketList(AU * au);
  
  /** creates one single SLPacket, deep-copies the
      part of @param payload specified by @param size 
      @param frag_offset is RFC2250 specific */
  virtual SLPacket * createSLPacket(u8 * payload, size_t size, bool fragment, u32 frag_offset);
  virtual u32 getMaxPacketPayloadSize() = 0;
  virtual u32 getPacketizationType() = 0;
protected:
  u32 packetSeqNumber;
};

#endif
