 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	Protocol.hpp                                                  *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

#ifndef _PS_PROXY_PROTOCOL
#define _PS_PROXY_PROTOCOL
#include "global.hpp"
#ifdef ISOMP4
#include "ISOMovies.h"
#endif

class Session;
enum KnownProtocols { PROTO_UNKNOWN = 0, PROTO_RTSP, PROTO_HTTP };

/**
 *
 * <Class Description goes here>
 *
 *@author Michael Kropfberger and Peter Schojer
 *
 *@version $Id: Protocol.hpp,v 1.4 2005/09/05 15:24:30 mkropfbe Exp $
 *
 *@short <short description>
 *
 */
class Protocol {
public:
	virtual ~Protocol() {};

	typedef enum {OK,NOTFOUND,ILLEGAL,UNKNOWNCMD} StatusValues;

	virtual bool applyReqToSession(const char *req, u32 bytesRead, Session * ses) = 0;

	KnownProtocols getID() { return protoID;	};

	virtual void generateFileNotFound()=0;

	virtual int getLastStatus() const=0;

	virtual const char* getBuffer() const=0;

	virtual int getDefaultPort() const=0;


protected:
	KnownProtocols protoID;
};
#endif
