 /***********************************************************************
 *                                                                      *
 * ViTooKi                                                              *
 *                                                                      *
 * title:	SyncLayer.cpp                                                 *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 * ITEC institute of the University of Klagenfurt (Austria)             *
 * http://www.itec.uni-klu.ac.at                                        *
 *                                                                      *
 *                                                                      *
 * For more information visit the ViTooKi homepage:                     *
 * http://ViTooKi.sourceforge.net                                       *
 * vitooki-user@lists.sourceforge.net                                   *
 * vitooki-devel@lists.sourceforge.net                                  *
 *                                                                      *
 * This file is part of ViTooKi, a free video toolkit.                  *
 * ViTooKi is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU General Public License          *
 * as published by the Free Software Foundation; either version 2       *
 * of the License, or (at your option) any later version.               *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *
 * MA  02111-1307, USA.                                                 *
 *                                                                      *
 ***********************************************************************/

 /***********************************************************************
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *                                                                      *
 *                                                                      *
 ***********************************************************************/

/****************************************************************
 Project: MPEG-4 Environment
 Purpose: Define SL Stream interface to higher layers
 Author:  M. Ohlenroth
 Date:    $Id: SyncLayer.cpp,v 1.5 2006/01/20 15:37:54 mkropfbe Exp $
 ****************************************************************/


//#include <stdint.h>
#ifndef WINCE
#include <sys/types.h>
#endif
#include "SyncLayer.hpp"

// predefined SLConfigDescriptor for RFC 3016 mode:
const SLConfigDescriptor slcd_rfc_3016 = {
	0, false, true, false, false,
	false, false, false, false,
	0, 0, 0, 0, 0,
	0, 0, 0, 0, 0x3,
	0, 0, 0,			// three unused values
	0, 0
};
	
	
bool operator == (SLPacketHeader const &first,
									SLPacketHeader const &second) {
	return first.accessUnitStartFlag == second.accessUnitStartFlag
		&& first.accessUnitEndFlag == second.accessUnitEndFlag
		&& first.OCRFlag == second.OCRFlag
		&& first.idleFlag == second.idleFlag
		&& first.paddingFlag == second.paddingFlag
		&& first.packetSequenceNumber == second.packetSequenceNumber
		&& first.DegPrioFlag == second.DegPrioFlag
		&& first.degradationPriority == second.degradationPriority
		&& first.objectClockReference == second.objectClockReference
		&& first.randomAccessPointFlag == second.randomAccessPointFlag
		&& first.AU_sequenceNumber == second.AU_sequenceNumber
		&& first.decodingTimeStampFlag == second.decodingTimeStampFlag
		&& first.compositionTimeStampFlag == second.compositionTimeStampFlag
		&& first.instantBitrateFlag == second.instantBitrateFlag
		&& first.decodingTimeStamp == second.decodingTimeStamp
		&& first.compositionTimeStamp == second.compositionTimeStamp
		&& first.accessUnitLength == second.accessUnitLength
		&& first.instantBitrate == second.instantBitrate;
};


SLPacket::SLPacket(SLPacketHeader Aslph, u8 * Apayload, size_t Apl_size,
									 void * extra_data, u32 extra_data_size) {

	//	dprintf_full("SLPacket construct size %i extra_data_size %i\n",Apl_size, extra_data_size);
	slph=Aslph;
	payload=Apayload;
	pl_size=Apl_size;
	payload = new u8[pl_size + extra_data_size];
	if(extra_data)
		memcpy(payload, extra_data, extra_data_size);
	if (payload)
		memcpy(payload + extra_data_size, Apayload, pl_size);
	pl_size += extra_data_size;
}
