#ifndef VITOOKI_HPP_
#define VITOOKI_HPP_
#ifdef ENABLE_FFMPEG
#ifndef ISOMP4
#include "avformat.h"
#else
#include "avcodec.h"
#endif
#endif //enable_ffmpeg
#ifdef WIN32
#include <winsock2.h>
#include <stdio.h>
#endif


//used for sched.h in phtreads lib (at least win32)
#ifdef WIN32
typedef int pid_t;
#endif



/** initializes ffmpeg */
void vitooki_init_codecs() {
#ifdef ENABLE_FFMPEG
#ifndef ISOMP4 
	av_register_all();
#else
  //init ffmpeg codecs, but not avformat
	avcodec_init();
	avcodec_register_all();
#endif
#endif
}


/** initializes network library. Exits program in case
  * of an error 
  */
void vitooki_init_network()
{
#ifdef WIN32
#ifdef WINCE
	WORD wVersionRequested;
	WSADATA wsaData;
	int err;
 
	wVersionRequested = MAKEWORD( 2, 2 );
 
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) {
		MessageBox(NULL,_T("Cannot initialize WinSock!"),_T("ERROR"),0);
		/* Tell the user that we could not find a usable */
		/* WinSock DLL.                                  */
		return;
	}

#else
	// do net init for stupid windows
	WSADATA wsaData;
	if (WSAStartup(MAKEWORD(1, 1), &wsaData) != 0) {
	printf("Failed to init network library\r\n");
	exit(1);
	}
#endif
#endif
};

/** initializes codecs and network for use by vitooki */
void vitooki_init_all()
{
	vitooki_init_codecs();
	vitooki_init_network();
};

#endif
